// VRML97/X3D file "helloWorld.x3dv" converted to java with white_dune

class X3dNode {
    void treeRender() {}
    void treeDoWithData() {}
    X3dNode m_parent;
};

class RenderCallback {
   public void render(X3dNode node) {}
}

class DoWithDataCallback {
   public void doWithData(X3dNode node) {}
}


class ColorRGBA extends X3dNode {
    X3dNode metadata;
    float[] color;
    int color_length;
    ColorRGBA() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderColorRGBA != null)
            X3dSceneGraph.callbackRenderColorRGBA.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataColorRGBA != null)
            X3dSceneGraph.callbackDoWithDataColorRGBA.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class ColorRGBARenderCallback extends RenderCallback {}
class ColorRGBADoWithDataCallback extends DoWithDataCallback {};


class BooleanFilter extends X3dNode {
    X3dNode metadata;
    BooleanFilter() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderBooleanFilter != null)
            X3dSceneGraph.callbackRenderBooleanFilter.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataBooleanFilter != null)
            X3dSceneGraph.callbackDoWithDataBooleanFilter.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class BooleanFilterRenderCallback extends RenderCallback {}
class BooleanFilterDoWithDataCallback extends DoWithDataCallback {};


class HAnimDisplacer extends X3dNode {
    X3dNode metadata;
    int[] coordIndex;
    int coordIndex_length;
    float[] displacements;
    int displacements_length;
    String name;
    float weight;
    HAnimDisplacer() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderHAnimDisplacer != null)
            X3dSceneGraph.callbackRenderHAnimDisplacer.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataHAnimDisplacer != null)
            X3dSceneGraph.callbackDoWithDataHAnimDisplacer.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class HAnimDisplacerRenderCallback extends RenderCallback {}
class HAnimDisplacerDoWithDataCallback extends DoWithDataCallback {};


class Billboard extends X3dNode {
    X3dNode metadata;
    float[] axisOfRotation;
    int axisOfRotation_length;
    X3dNode [] children;
    int children_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    Billboard() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderBillboard != null)
            X3dSceneGraph.callbackRenderBillboard.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataBillboard != null)
            X3dSceneGraph.callbackDoWithDataBillboard.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
    }
}

class BillboardRenderCallback extends RenderCallback {}
class BillboardDoWithDataCallback extends DoWithDataCallback {};


class Contour2D extends X3dNode {
    X3dNode metadata;
    X3dNode [] children;
    int children_length;
    Contour2D() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderContour2D != null)
            X3dSceneGraph.callbackRenderContour2D.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataContour2D != null)
            X3dSceneGraph.callbackDoWithDataContour2D.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
    }
}

class Contour2DRenderCallback extends RenderCallback {}
class Contour2DDoWithDataCallback extends DoWithDataCallback {};


class HAnimJoint extends X3dNode {
    X3dNode metadata;
    float[] rotation;
    int rotation_length;
    float[] translation;
    int translation_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    float[] center;
    int center_length;
    float[] scale;
    int scale_length;
    float[] scaleOrientation;
    int scaleOrientation_length;
    X3dNode [] children;
    int children_length;
    X3dNode [] displacers;
    int displacers_length;
    float[] limitOrientation;
    int limitOrientation_length;
    float[] llimit;
    int llimit_length;
    String name;
    int[] skinCoordIndex;
    int skinCoordIndex_length;
    float[] skinCoordWeight;
    int skinCoordWeight_length;
    float[] stiffness;
    int stiffness_length;
    float[] ulimit;
    int ulimit_length;
    HAnimJoint() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderHAnimJoint != null)
            X3dSceneGraph.callbackRenderHAnimJoint.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
        for (int i = 0; i < displacers_length; i++)
            if (displacers[i] != null)
                displacers[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataHAnimJoint != null)
            X3dSceneGraph.callbackDoWithDataHAnimJoint.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
        for (int i = 0; i < displacers_length; i++)
            if (displacers[i] != null)
                displacers[i].treeDoWithData();
    }
}

class HAnimJointRenderCallback extends RenderCallback {}
class HAnimJointDoWithDataCallback extends DoWithDataCallback {};


class SpotLight extends X3dNode {
    X3dNode metadata;
    float ambientIntensity;
    float[] attenuation;
    int attenuation_length;
    float beamWidth;
    float[] color;
    int color_length;
    float cutOffAngle;
    float[] direction;
    int direction_length;
    float intensity;
    float[] location;
    int location_length;
    boolean on;
    float radius;
    boolean kambiShadows;
    boolean kambiShadowsMain;
    SpotLight() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderSpotLight != null)
            X3dSceneGraph.callbackRenderSpotLight.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataSpotLight != null)
            X3dSceneGraph.callbackDoWithDataSpotLight.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class SpotLightRenderCallback extends RenderCallback {}
class SpotLightDoWithDataCallback extends DoWithDataCallback {};


class UniversalJoint extends X3dNode {
    X3dNode metadata;
    X3dNode body1;
    X3dNode body2;
    String[] forceOutput;
    int forceOutput_length;
    float[] anchorPoint;
    int anchorPoint_length;
    float[] axis1;
    int axis1_length;
    float[] axis2;
    int axis2_length;
    float stop1Bounce;
    float stop1ErrorCorrection;
    float stop2Bounce;
    float stop2ErrorCorrection;
    UniversalJoint() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderUniversalJoint != null)
            X3dSceneGraph.callbackRenderUniversalJoint.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (body1 != null)
            body1.treeRender();
        if (body2 != null)
            body2.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataUniversalJoint != null)
            X3dSceneGraph.callbackDoWithDataUniversalJoint.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (body1 != null)
            body1.treeDoWithData();
        if (body2 != null)
            body2.treeDoWithData();
    }
}

class UniversalJointRenderCallback extends RenderCallback {}
class UniversalJointDoWithDataCallback extends DoWithDataCallback {};


class GeoCoordinate extends X3dNode {
    X3dNode metadata;
    X3dNode geoOrigin;
    String[] geoSystem;
    int geoSystem_length;
    double[] point;
    int point_length;
    GeoCoordinate() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderGeoCoordinate != null)
            X3dSceneGraph.callbackRenderGeoCoordinate.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (geoOrigin != null)
            geoOrigin.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataGeoCoordinate != null)
            X3dSceneGraph.callbackDoWithDataGeoCoordinate.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (geoOrigin != null)
            geoOrigin.treeDoWithData();
    }
}

class GeoCoordinateRenderCallback extends RenderCallback {}
class GeoCoordinateDoWithDataCallback extends DoWithDataCallback {};


class Sphere extends X3dNode {
    X3dNode metadata;
    float radius;
    boolean solid;
    Sphere() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderSphere != null)
            X3dSceneGraph.callbackRenderSphere.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataSphere != null)
            X3dSceneGraph.callbackDoWithDataSphere.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class SphereRenderCallback extends RenderCallback {}
class SphereDoWithDataCallback extends DoWithDataCallback {};


class SuperShape extends X3dNode {
    X3dNode metadata;
    float ua;
    float ub;
    float um;
    float un1;
    float un2;
    float un3;
    float va;
    float vb;
    float vm;
    float vn1;
    float vn2;
    float vn3;
    boolean bottom;
    float bottomBorder;
    float border;
    boolean ccw;
    float creaseAngle;
    float[] size;
    int size_length;
    boolean solid;
    X3dNode texCoord;
    boolean top;
    int uTessellation;
    int vTessellation;
    SuperShape() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderSuperShape != null)
            X3dSceneGraph.callbackRenderSuperShape.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (texCoord != null)
            texCoord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataSuperShape != null)
            X3dSceneGraph.callbackDoWithDataSuperShape.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (texCoord != null)
            texCoord.treeDoWithData();
    }
}

class SuperShapeRenderCallback extends RenderCallback {}
class SuperShapeDoWithDataCallback extends DoWithDataCallback {};


class TransmitterPdu extends X3dNode {
    X3dNode metadata;
    float[] antennaLocation;
    int antennaLocation_length;
    int antennaPatternLength;
    int antennaPatternType;
    int cryptoKeyID;
    int cryptoSystem;
    int frequency;
    int inputSource;
    int lengthOfModulationParameters;
    int modulationTypeDetail;
    int modulationTypeMajor;
    int modulationTypeSpreadSpectrum;
    int modulationTypeSystem;
    float power;
    int radioEntityTypeCategory;
    int radioEntityTypeCountry;
    int radioEntityTypeDomain;
    int radioEntityTypeKind;
    int radioEntityTypeNomenclature;
    int radioEntityTypeNomenclatureVersion;
    int radioID;
    float[] relativeAntennaLocation;
    int relativeAntennaLocation_length;
    float transmitFrequencyBandwidth;
    int transmitState;
    int whichGeometry;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    String networkMode;
    double readInterval;
    double writeInterval;
    int siteID;
    int applicationID;
    int entityID;
    String address;
    int port;
    String multicastRelayHost;
    int multicastRelayPort;
    boolean rtpHeaderExpected;
    TransmitterPdu() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderTransmitterPdu != null)
            X3dSceneGraph.callbackRenderTransmitterPdu.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataTransmitterPdu != null)
            X3dSceneGraph.callbackDoWithDataTransmitterPdu.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class TransmitterPduRenderCallback extends RenderCallback {}
class TransmitterPduDoWithDataCallback extends DoWithDataCallback {};


class Transform extends X3dNode {
    X3dNode metadata;
    float[] rotation;
    int rotation_length;
    float[] translation;
    int translation_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    float[] center;
    int center_length;
    float[] scale;
    int scale_length;
    float[] scaleOrientation;
    int scaleOrientation_length;
    X3dNode [] children;
    int children_length;
    Transform() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderTransform != null)
            X3dSceneGraph.callbackRenderTransform.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataTransform != null)
            X3dSceneGraph.callbackDoWithDataTransform.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
    }
}

class TransformRenderCallback extends RenderCallback {}
class TransformDoWithDataCallback extends DoWithDataCallback {};


class RigidBodyCollection extends X3dNode {
    X3dNode metadata;
    boolean autoDisable;
    X3dNode [] bodies;
    int bodies_length;
    float constantForceMix;
    float contactSurfaceThickness;
    float disableAngularSpeed;
    float disableLinearSpeed;
    float disableTime;
    boolean enabled;
    float errorCorrection;
    float[] gravity;
    int gravity_length;
    int iterations;
    X3dNode [] joints;
    int joints_length;
    float maxCorrectionSpeed;
    boolean preferAccuracy;
    X3dNode collider;
    RigidBodyCollection() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderRigidBodyCollection != null)
            X3dSceneGraph.callbackRenderRigidBodyCollection.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < bodies_length; i++)
            if (bodies[i] != null)
                bodies[i].treeRender();
        for (int i = 0; i < joints_length; i++)
            if (joints[i] != null)
                joints[i].treeRender();
        if (collider != null)
            collider.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataRigidBodyCollection != null)
            X3dSceneGraph.callbackDoWithDataRigidBodyCollection.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < bodies_length; i++)
            if (bodies[i] != null)
                bodies[i].treeDoWithData();
        for (int i = 0; i < joints_length; i++)
            if (joints[i] != null)
                joints[i].treeDoWithData();
        if (collider != null)
            collider.treeDoWithData();
    }
}

class RigidBodyCollectionRenderCallback extends RenderCallback {}
class RigidBodyCollectionDoWithDataCallback extends DoWithDataCallback {};


class SuperExtrusion extends X3dNode {
    X3dNode metadata;
    float a;
    float b;
    float m;
    float n1;
    float n2;
    float n3;
    float border;
    float bottomBorder;
    int superTessellation;
    int spineTessellation;
    float[] controlPoint;
    int controlPoint_length;
    float[] weight;
    int weight_length;
    float[] knot;
    int knot_length;
    int order;
    float creaseAngle;
    boolean beginCap;
    boolean endCap;
    float[] scale;
    int scale_length;
    SuperExtrusion() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderSuperExtrusion != null)
            X3dSceneGraph.callbackRenderSuperExtrusion.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataSuperExtrusion != null)
            X3dSceneGraph.callbackDoWithDataSuperExtrusion.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class SuperExtrusionRenderCallback extends RenderCallback {}
class SuperExtrusionDoWithDataCallback extends DoWithDataCallback {};


class GeoMetadata extends X3dNode {
    X3dNode metadata;
    X3dNode [] data;
    int data_length;
    String[] summary;
    int summary_length;
    String[] url;
    int url_length;
    GeoMetadata() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderGeoMetadata != null)
            X3dSceneGraph.callbackRenderGeoMetadata.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < data_length; i++)
            if (data[i] != null)
                data[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataGeoMetadata != null)
            X3dSceneGraph.callbackDoWithDataGeoMetadata.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < data_length; i++)
            if (data[i] != null)
                data[i].treeDoWithData();
    }
}

class GeoMetadataRenderCallback extends RenderCallback {}
class GeoMetadataDoWithDataCallback extends DoWithDataCallback {};


class ColorInterpolator extends X3dNode {
    X3dNode metadata;
    float[] key;
    int key_length;
    float[] keyValue;
    int keyValue_length;
    ColorInterpolator() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderColorInterpolator != null)
            X3dSceneGraph.callbackRenderColorInterpolator.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataColorInterpolator != null)
            X3dSceneGraph.callbackDoWithDataColorInterpolator.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class ColorInterpolatorRenderCallback extends RenderCallback {}
class ColorInterpolatorDoWithDataCallback extends DoWithDataCallback {};


class CylinderSensor extends X3dNode {
    X3dNode metadata;
    boolean autoOffset;
    String description;
    float diskAngle;
    boolean enabled;
    float maxAngle;
    float minAngle;
    float offset;
    CylinderSensor() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCylinderSensor != null)
            X3dSceneGraph.callbackRenderCylinderSensor.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCylinderSensor != null)
            X3dSceneGraph.callbackDoWithDataCylinderSensor.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class CylinderSensorRenderCallback extends RenderCallback {}
class CylinderSensorDoWithDataCallback extends DoWithDataCallback {};


class LoadSensor extends X3dNode {
    X3dNode metadata;
    boolean enabled;
    double timeOut;
    X3dNode [] watchList;
    int watchList_length;
    LoadSensor() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderLoadSensor != null)
            X3dSceneGraph.callbackRenderLoadSensor.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < watchList_length; i++)
            if (watchList[i] != null)
                watchList[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataLoadSensor != null)
            X3dSceneGraph.callbackDoWithDataLoadSensor.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < watchList_length; i++)
            if (watchList[i] != null)
                watchList[i].treeDoWithData();
    }
}

class LoadSensorRenderCallback extends RenderCallback {}
class LoadSensorDoWithDataCallback extends DoWithDataCallback {};


class SuperRevolver extends X3dNode {
    X3dNode metadata;
    float a;
    float b;
    float m;
    float n1;
    float n2;
    float n3;
    float border;
    float bottomBorder;
    int superTessellation;
    int nurbsTessellation;
    float[] controlPoint;
    int controlPoint_length;
    float[] weight;
    int weight_length;
    float[] knot;
    int knot_length;
    int order;
    float creaseAngle;
    boolean ccw;
    boolean solid;
    boolean pieceOfCake;
    SuperRevolver() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderSuperRevolver != null)
            X3dSceneGraph.callbackRenderSuperRevolver.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataSuperRevolver != null)
            X3dSceneGraph.callbackDoWithDataSuperRevolver.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class SuperRevolverRenderCallback extends RenderCallback {}
class SuperRevolverDoWithDataCallback extends DoWithDataCallback {};


class TextureCoordinateGenerator extends X3dNode {
    X3dNode metadata;
    String mode;
    float[] parameter;
    int parameter_length;
    TextureCoordinateGenerator() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderTextureCoordinateGenerator != null)
            X3dSceneGraph.callbackRenderTextureCoordinateGenerator.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataTextureCoordinateGenerator != null)
            X3dSceneGraph.callbackDoWithDataTextureCoordinateGenerator.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class TextureCoordinateGeneratorRenderCallback extends RenderCallback {}
class TextureCoordinateGeneratorDoWithDataCallback extends DoWithDataCallback {};


class LineProperties extends X3dNode {
    X3dNode metadata;
    boolean applied;
    int linetype;
    float linewidthScaleFactor;
    LineProperties() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderLineProperties != null)
            X3dSceneGraph.callbackRenderLineProperties.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataLineProperties != null)
            X3dSceneGraph.callbackDoWithDataLineProperties.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class LinePropertiesRenderCallback extends RenderCallback {}
class LinePropertiesDoWithDataCallback extends DoWithDataCallback {};


class ArcClose2D extends X3dNode {
    X3dNode metadata;
    String closureType;
    float endAngle;
    float radius;
    boolean solid;
    float startAngle;
    ArcClose2D() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderArcClose2D != null)
            X3dSceneGraph.callbackRenderArcClose2D.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataArcClose2D != null)
            X3dSceneGraph.callbackDoWithDataArcClose2D.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class ArcClose2DRenderCallback extends RenderCallback {}
class ArcClose2DDoWithDataCallback extends DoWithDataCallback {};


class ElevationGrid extends X3dNode {
    X3dNode metadata;
    X3dNode color;
    X3dNode normal;
    X3dNode texCoord;
    boolean ccw;
    boolean colorPerVertex;
    float creaseAngle;
    float[] height;
    int height_length;
    boolean normalPerVertex;
    boolean solid;
    int xDimension;
    float xSpacing;
    int zDimension;
    float zSpacing;
    ElevationGrid() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderElevationGrid != null)
            X3dSceneGraph.callbackRenderElevationGrid.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (color != null)
            color.treeRender();
        if (normal != null)
            normal.treeRender();
        if (texCoord != null)
            texCoord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataElevationGrid != null)
            X3dSceneGraph.callbackDoWithDataElevationGrid.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (color != null)
            color.treeDoWithData();
        if (normal != null)
            normal.treeDoWithData();
        if (texCoord != null)
            texCoord.treeDoWithData();
    }
}

class ElevationGridRenderCallback extends RenderCallback {}
class ElevationGridDoWithDataCallback extends DoWithDataCallback {};


class IndexedTriangleFanSet extends X3dNode {
    X3dNode metadata;
    X3dNode color;
    X3dNode coord;
    X3dNode normal;
    X3dNode texCoord;
    boolean ccw;
    boolean normalPerVertex;
    boolean solid;
    int[] index;
    int index_length;
    boolean colorPerVertex;
    IndexedTriangleFanSet() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderIndexedTriangleFanSet != null)
            X3dSceneGraph.callbackRenderIndexedTriangleFanSet.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (color != null)
            color.treeRender();
        if (coord != null)
            coord.treeRender();
        if (normal != null)
            normal.treeRender();
        if (texCoord != null)
            texCoord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataIndexedTriangleFanSet != null)
            X3dSceneGraph.callbackDoWithDataIndexedTriangleFanSet.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (color != null)
            color.treeDoWithData();
        if (coord != null)
            coord.treeDoWithData();
        if (normal != null)
            normal.treeDoWithData();
        if (texCoord != null)
            texCoord.treeDoWithData();
    }
}

class IndexedTriangleFanSetRenderCallback extends RenderCallback {}
class IndexedTriangleFanSetDoWithDataCallback extends DoWithDataCallback {};


class LineSet extends X3dNode {
    X3dNode metadata;
    X3dNode color;
    X3dNode coord;
    int[] vertexCount;
    int vertexCount_length;
    LineSet() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderLineSet != null)
            X3dSceneGraph.callbackRenderLineSet.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (color != null)
            color.treeRender();
        if (coord != null)
            coord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataLineSet != null)
            X3dSceneGraph.callbackDoWithDataLineSet.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (color != null)
            color.treeDoWithData();
        if (coord != null)
            coord.treeDoWithData();
    }
}

class LineSetRenderCallback extends RenderCallback {}
class LineSetDoWithDataCallback extends DoWithDataCallback {};


class NurbsCurve2D extends X3dNode {
    X3dNode metadata;
    float[] controlPoint;
    int controlPoint_length;
    int tessellation;
    float[] weight;
    int weight_length;
    boolean closed;
    float[] knot;
    int knot_length;
    int order;
    NurbsCurve2D() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNurbsCurve2D != null)
            X3dSceneGraph.callbackRenderNurbsCurve2D.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNurbsCurve2D != null)
            X3dSceneGraph.callbackDoWithDataNurbsCurve2D.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class NurbsCurve2DRenderCallback extends RenderCallback {}
class NurbsCurve2DDoWithDataCallback extends DoWithDataCallback {};


class NurbsSet extends X3dNode {
    X3dNode metadata;
    X3dNode [] geometry;
    int geometry_length;
    float tessellationScale;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    NurbsSet() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNurbsSet != null)
            X3dSceneGraph.callbackRenderNurbsSet.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < geometry_length; i++)
            if (geometry[i] != null)
                geometry[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNurbsSet != null)
            X3dSceneGraph.callbackDoWithDataNurbsSet.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < geometry_length; i++)
            if (geometry[i] != null)
                geometry[i].treeDoWithData();
    }
}

class NurbsSetRenderCallback extends RenderCallback {}
class NurbsSetDoWithDataCallback extends DoWithDataCallback {};


class TriangleStripSet extends X3dNode {
    X3dNode metadata;
    X3dNode color;
    X3dNode coord;
    X3dNode normal;
    int[] stripCount;
    int stripCount_length;
    X3dNode texCoord;
    boolean ccw;
    boolean colorPerVertex;
    float creaseAngle;
    boolean normalPerVertex;
    boolean solid;
    TriangleStripSet() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderTriangleStripSet != null)
            X3dSceneGraph.callbackRenderTriangleStripSet.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (color != null)
            color.treeRender();
        if (coord != null)
            coord.treeRender();
        if (normal != null)
            normal.treeRender();
        if (texCoord != null)
            texCoord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataTriangleStripSet != null)
            X3dSceneGraph.callbackDoWithDataTriangleStripSet.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (color != null)
            color.treeDoWithData();
        if (coord != null)
            coord.treeDoWithData();
        if (normal != null)
            normal.treeDoWithData();
        if (texCoord != null)
            texCoord.treeDoWithData();
    }
}

class TriangleStripSetRenderCallback extends RenderCallback {}
class TriangleStripSetDoWithDataCallback extends DoWithDataCallback {};


class VrmlCut extends X3dNode {
    X3dNode metadata;
    double[] sceneLengths;
    int sceneLengths_length;
    int sceneNumber;
    X3dNode [] scenes;
    int scenes_length;
    int numberPreviousScenes;
    int numberNextScenes;
    VrmlCut() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderVrmlCut != null)
            X3dSceneGraph.callbackRenderVrmlCut.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < scenes_length; i++)
            if (scenes[i] != null)
                scenes[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataVrmlCut != null)
            X3dSceneGraph.callbackDoWithDataVrmlCut.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < scenes_length; i++)
            if (scenes[i] != null)
                scenes[i].treeDoWithData();
    }
}

class VrmlCutRenderCallback extends RenderCallback {}
class VrmlCutDoWithDataCallback extends DoWithDataCallback {};


class CollidableShape extends X3dNode {
    X3dNode metadata;
    boolean enabled;
    float[] rotation;
    int rotation_length;
    float[] translation;
    int translation_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    X3dNode shape;
    CollidableShape() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCollidableShape != null)
            X3dSceneGraph.callbackRenderCollidableShape.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (shape != null)
            shape.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCollidableShape != null)
            X3dSceneGraph.callbackDoWithDataCollidableShape.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (shape != null)
            shape.treeDoWithData();
    }
}

class CollidableShapeRenderCallback extends RenderCallback {}
class CollidableShapeDoWithDataCallback extends DoWithDataCallback {};


class NurbsSurface extends X3dNode {
    X3dNode metadata;
    int uDimension;
    int vDimension;
    float[] uKnot;
    int uKnot_length;
    float[] vKnot;
    int vKnot_length;
    int uOrder;
    int vOrder;
    X3dNode controlPoint;
    float[] weight;
    int weight_length;
    int uTessellation;
    int vTessellation;
    X3dNode texCoord;
    boolean ccw;
    boolean solid;
    NurbsSurface() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNurbsSurface != null)
            X3dSceneGraph.callbackRenderNurbsSurface.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (controlPoint != null)
            controlPoint.treeRender();
        if (texCoord != null)
            texCoord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNurbsSurface != null)
            X3dSceneGraph.callbackDoWithDataNurbsSurface.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (controlPoint != null)
            controlPoint.treeDoWithData();
        if (texCoord != null)
            texCoord.treeDoWithData();
    }
}

class NurbsSurfaceRenderCallback extends RenderCallback {}
class NurbsSurfaceDoWithDataCallback extends DoWithDataCallback {};


class NurbsSweptSurface extends X3dNode {
    X3dNode metadata;
    X3dNode crossSectionCurve;
    X3dNode trajectoryCurve;
    boolean ccw;
    boolean solid;
    NurbsSweptSurface() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNurbsSweptSurface != null)
            X3dSceneGraph.callbackRenderNurbsSweptSurface.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (crossSectionCurve != null)
            crossSectionCurve.treeRender();
        if (trajectoryCurve != null)
            trajectoryCurve.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNurbsSweptSurface != null)
            X3dSceneGraph.callbackDoWithDataNurbsSweptSurface.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (crossSectionCurve != null)
            crossSectionCurve.treeDoWithData();
        if (trajectoryCurve != null)
            trajectoryCurve.treeDoWithData();
    }
}

class NurbsSweptSurfaceRenderCallback extends RenderCallback {}
class NurbsSweptSurfaceDoWithDataCallback extends DoWithDataCallback {};


class PixelTexture extends X3dNode {
    X3dNode metadata;
    int[] image;
    int image_length;
    boolean repeatS;
    boolean repeatT;
    PixelTexture() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderPixelTexture != null)
            X3dSceneGraph.callbackRenderPixelTexture.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataPixelTexture != null)
            X3dSceneGraph.callbackDoWithDataPixelTexture.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class PixelTextureRenderCallback extends RenderCallback {}
class PixelTextureDoWithDataCallback extends DoWithDataCallback {};


class Switch extends X3dNode {
    X3dNode metadata;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    X3dNode [] children;
    int children_length;
    int whichChoice;
    Switch() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderSwitch != null)
            X3dSceneGraph.callbackRenderSwitch.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataSwitch != null)
            X3dSceneGraph.callbackDoWithDataSwitch.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
    }
}

class SwitchRenderCallback extends RenderCallback {}
class SwitchDoWithDataCallback extends DoWithDataCallback {};


class CollisionSensor extends X3dNode {
    X3dNode metadata;
    X3dNode collidables;
    boolean enabled;
    CollisionSensor() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCollisionSensor != null)
            X3dSceneGraph.callbackRenderCollisionSensor.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (collidables != null)
            collidables.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCollisionSensor != null)
            X3dSceneGraph.callbackDoWithDataCollisionSensor.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (collidables != null)
            collidables.treeDoWithData();
    }
}

class CollisionSensorRenderCallback extends RenderCallback {}
class CollisionSensorDoWithDataCallback extends DoWithDataCallback {};


class GeoTouchSensor extends X3dNode {
    X3dNode metadata;
    X3dNode geoOrigin;
    String[] geoSystem;
    int geoSystem_length;
    String description;
    boolean enabled;
    GeoTouchSensor() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderGeoTouchSensor != null)
            X3dSceneGraph.callbackRenderGeoTouchSensor.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (geoOrigin != null)
            geoOrigin.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataGeoTouchSensor != null)
            X3dSceneGraph.callbackDoWithDataGeoTouchSensor.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (geoOrigin != null)
            geoOrigin.treeDoWithData();
    }
}

class GeoTouchSensorRenderCallback extends RenderCallback {}
class GeoTouchSensorDoWithDataCallback extends DoWithDataCallback {};


class IntegerSequencer extends X3dNode {
    X3dNode metadata;
    float[] key;
    int key_length;
    int[] keyValue;
    int keyValue_length;
    IntegerSequencer() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderIntegerSequencer != null)
            X3dSceneGraph.callbackRenderIntegerSequencer.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataIntegerSequencer != null)
            X3dSceneGraph.callbackDoWithDataIntegerSequencer.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class IntegerSequencerRenderCallback extends RenderCallback {}
class IntegerSequencerDoWithDataCallback extends DoWithDataCallback {};


class KeySensor extends X3dNode {
    X3dNode metadata;
    boolean enabled;
    KeySensor() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderKeySensor != null)
            X3dSceneGraph.callbackRenderKeySensor.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataKeySensor != null)
            X3dSceneGraph.callbackDoWithDataKeySensor.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class KeySensorRenderCallback extends RenderCallback {}
class KeySensorDoWithDataCallback extends DoWithDataCallback {};


class PlaneSensor extends X3dNode {
    X3dNode metadata;
    boolean autoOffset;
    String description;
    boolean enabled;
    float[] maxPosition;
    int maxPosition_length;
    float[] minPosition;
    int minPosition_length;
    float[] offset;
    int offset_length;
    PlaneSensor() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderPlaneSensor != null)
            X3dSceneGraph.callbackRenderPlaneSensor.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataPlaneSensor != null)
            X3dSceneGraph.callbackDoWithDataPlaneSensor.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class PlaneSensorRenderCallback extends RenderCallback {}
class PlaneSensorDoWithDataCallback extends DoWithDataCallback {};


class StringSensor extends X3dNode {
    X3dNode metadata;
    boolean deletionAllowed;
    boolean enabled;
    StringSensor() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderStringSensor != null)
            X3dSceneGraph.callbackRenderStringSensor.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataStringSensor != null)
            X3dSceneGraph.callbackDoWithDataStringSensor.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class StringSensorRenderCallback extends RenderCallback {}
class StringSensorDoWithDataCallback extends DoWithDataCallback {};


class CoordinateInterpolator2D extends X3dNode {
    X3dNode metadata;
    float[] key;
    int key_length;
    float[] keyValue;
    int keyValue_length;
    CoordinateInterpolator2D() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCoordinateInterpolator2D != null)
            X3dSceneGraph.callbackRenderCoordinateInterpolator2D.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCoordinateInterpolator2D != null)
            X3dSceneGraph.callbackDoWithDataCoordinateInterpolator2D.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class CoordinateInterpolator2DRenderCallback extends RenderCallback {}
class CoordinateInterpolator2DDoWithDataCallback extends DoWithDataCallback {};


class DoubleAxisHingeJoint extends X3dNode {
    X3dNode metadata;
    X3dNode body1;
    X3dNode body2;
    String[] forceOutput;
    int forceOutput_length;
    float[] anchorPoint;
    int anchorPoint_length;
    float[] axis1;
    int axis1_length;
    float[] axis2;
    int axis2_length;
    float desiredAngularVelocity1;
    float desiredAngularVelocity2;
    float maxAngle1;
    float maxTorque1;
    float maxTorque2;
    float minAngle1;
    float stopBounce1;
    float stopConstantForceMix1;
    float stopErrorCorrection1;
    float suspensionErrorCorrection;
    float suspensionForce;
    DoubleAxisHingeJoint() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderDoubleAxisHingeJoint != null)
            X3dSceneGraph.callbackRenderDoubleAxisHingeJoint.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (body1 != null)
            body1.treeRender();
        if (body2 != null)
            body2.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataDoubleAxisHingeJoint != null)
            X3dSceneGraph.callbackDoWithDataDoubleAxisHingeJoint.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (body1 != null)
            body1.treeDoWithData();
        if (body2 != null)
            body2.treeDoWithData();
    }
}

class DoubleAxisHingeJointRenderCallback extends RenderCallback {}
class DoubleAxisHingeJointDoWithDataCallback extends DoWithDataCallback {};


class GeoViewpoint extends X3dNode {
    X3dNode metadata;
    X3dNode geoOrigin;
    String[] geoSystem;
    int geoSystem_length;
    String description;
    float fieldOfView;
    boolean headlight;
    boolean jump;
    String[] navType;
    int navType_length;
    float[] orientation;
    int orientation_length;
    double[] position;
    int position_length;
    float speedFactor;
    GeoViewpoint() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderGeoViewpoint != null)
            X3dSceneGraph.callbackRenderGeoViewpoint.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (geoOrigin != null)
            geoOrigin.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataGeoViewpoint != null)
            X3dSceneGraph.callbackDoWithDataGeoViewpoint.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (geoOrigin != null)
            geoOrigin.treeDoWithData();
    }
}

class GeoViewpointRenderCallback extends RenderCallback {}
class GeoViewpointDoWithDataCallback extends DoWithDataCallback {};


class OdeSliderJoint extends X3dNode {
    X3dNode metadata;
    X3dNode body1;
    X3dNode body2;
    String[] forceOutput;
    int forceOutput_length;
    float[] axis;
    int axis_length;
    float maxSeparation;
    float minSeparation;
    float stopBounce;
    float stopErrorCorrection;
    float fMax;
    OdeSliderJoint() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderOdeSliderJoint != null)
            X3dSceneGraph.callbackRenderOdeSliderJoint.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (body1 != null)
            body1.treeRender();
        if (body2 != null)
            body2.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataOdeSliderJoint != null)
            X3dSceneGraph.callbackDoWithDataOdeSliderJoint.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (body1 != null)
            body1.treeDoWithData();
        if (body2 != null)
            body2.treeDoWithData();
    }
}

class OdeSliderJointRenderCallback extends RenderCallback {}
class OdeSliderJointDoWithDataCallback extends DoWithDataCallback {};


class Polyline2D extends X3dNode {
    X3dNode metadata;
    float[] lineSegments;
    int lineSegments_length;
    Polyline2D() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderPolyline2D != null)
            X3dSceneGraph.callbackRenderPolyline2D.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataPolyline2D != null)
            X3dSceneGraph.callbackDoWithDataPolyline2D.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class Polyline2DRenderCallback extends RenderCallback {}
class Polyline2DDoWithDataCallback extends DoWithDataCallback {};


class PositionInterpolator2D extends X3dNode {
    X3dNode metadata;
    float[] key;
    int key_length;
    float[] keyValue;
    int keyValue_length;
    PositionInterpolator2D() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderPositionInterpolator2D != null)
            X3dSceneGraph.callbackRenderPositionInterpolator2D.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataPositionInterpolator2D != null)
            X3dSceneGraph.callbackDoWithDataPositionInterpolator2D.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class PositionInterpolator2DRenderCallback extends RenderCallback {}
class PositionInterpolator2DDoWithDataCallback extends DoWithDataCallback {};


class Viewpoint extends X3dNode {
    X3dNode metadata;
    float[] centerOfRotation;
    int centerOfRotation_length;
    String description;
    float fieldOfView;
    boolean jump;
    float[] orientation;
    int orientation_length;
    float[] position;
    int position_length;
    Viewpoint() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderViewpoint != null)
            X3dSceneGraph.callbackRenderViewpoint.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataViewpoint != null)
            X3dSceneGraph.callbackDoWithDataViewpoint.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class ViewpointRenderCallback extends RenderCallback {}
class ViewpointDoWithDataCallback extends DoWithDataCallback {};


class HAnimSite extends X3dNode {
    X3dNode metadata;
    float[] rotation;
    int rotation_length;
    float[] translation;
    int translation_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    float[] center;
    int center_length;
    float[] scale;
    int scale_length;
    float[] scaleOrientation;
    int scaleOrientation_length;
    X3dNode [] children;
    int children_length;
    String name;
    HAnimSite() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderHAnimSite != null)
            X3dSceneGraph.callbackRenderHAnimSite.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataHAnimSite != null)
            X3dSceneGraph.callbackDoWithDataHAnimSite.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
    }
}

class HAnimSiteRenderCallback extends RenderCallback {}
class HAnimSiteDoWithDataCallback extends DoWithDataCallback {};


class ImageTexture extends X3dNode {
    X3dNode metadata;
    String[] url;
    int url_length;
    boolean repeatS;
    boolean repeatT;
    ImageTexture() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderImageTexture != null)
            X3dSceneGraph.callbackRenderImageTexture.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataImageTexture != null)
            X3dSceneGraph.callbackDoWithDataImageTexture.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class ImageTextureRenderCallback extends RenderCallback {}
class ImageTextureDoWithDataCallback extends DoWithDataCallback {};


class MovieTexture extends X3dNode {
    X3dNode metadata;
    boolean loop;
    float speed;
    double pauseTime;
    double resumeTime;
    double startTime;
    double stopTime;
    String[] url;
    int url_length;
    boolean repeatS;
    boolean repeatT;
    MovieTexture() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderMovieTexture != null)
            X3dSceneGraph.callbackRenderMovieTexture.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataMovieTexture != null)
            X3dSceneGraph.callbackDoWithDataMovieTexture.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class MovieTextureRenderCallback extends RenderCallback {}
class MovieTextureDoWithDataCallback extends DoWithDataCallback {};


class Extrusion extends X3dNode {
    X3dNode metadata;
    boolean beginCap;
    boolean ccw;
    boolean convex;
    float creaseAngle;
    float[] crossSection;
    int crossSection_length;
    boolean endCap;
    float[] orientation;
    int orientation_length;
    float[] scale;
    int scale_length;
    boolean solid;
    float[] spine;
    int spine_length;
    Extrusion() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderExtrusion != null)
            X3dSceneGraph.callbackRenderExtrusion.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataExtrusion != null)
            X3dSceneGraph.callbackDoWithDataExtrusion.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class ExtrusionRenderCallback extends RenderCallback {}
class ExtrusionDoWithDataCallback extends DoWithDataCallback {};


class NavigationInfo extends X3dNode {
    X3dNode metadata;
    float[] avatarSize;
    int avatarSize_length;
    boolean headlight;
    float speed;
    String[] transistionType;
    int transistionType_length;
    String[] type;
    int type_length;
    float visibilityLimit;
    NavigationInfo() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNavigationInfo != null)
            X3dSceneGraph.callbackRenderNavigationInfo.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNavigationInfo != null)
            X3dSceneGraph.callbackDoWithDataNavigationInfo.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class NavigationInfoRenderCallback extends RenderCallback {}
class NavigationInfoDoWithDataCallback extends DoWithDataCallback {};


class WorldInfo extends X3dNode {
    X3dNode metadata;
    String[] info;
    int info_length;
    String title;
    WorldInfo() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderWorldInfo != null)
            X3dSceneGraph.callbackRenderWorldInfo.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataWorldInfo != null)
            X3dSceneGraph.callbackDoWithDataWorldInfo.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class WorldInfoRenderCallback extends RenderCallback {}
class WorldInfoDoWithDataCallback extends DoWithDataCallback {};


class AudioClip extends X3dNode {
    X3dNode metadata;
    String description;
    boolean loop;
    double pauseTime;
    float pitch;
    double resumeTime;
    double startTime;
    double stopTime;
    String[] url;
    int url_length;
    AudioClip() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderAudioClip != null)
            X3dSceneGraph.callbackRenderAudioClip.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataAudioClip != null)
            X3dSceneGraph.callbackDoWithDataAudioClip.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class AudioClipRenderCallback extends RenderCallback {}
class AudioClipDoWithDataCallback extends DoWithDataCallback {};


class CoordinateInterpolator extends X3dNode {
    X3dNode metadata;
    float[] key;
    int key_length;
    float[] keyValue;
    int keyValue_length;
    CoordinateInterpolator() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCoordinateInterpolator != null)
            X3dSceneGraph.callbackRenderCoordinateInterpolator.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCoordinateInterpolator != null)
            X3dSceneGraph.callbackDoWithDataCoordinateInterpolator.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class CoordinateInterpolatorRenderCallback extends RenderCallback {}
class CoordinateInterpolatorDoWithDataCallback extends DoWithDataCallback {};


class IntegerTrigger extends X3dNode {
    X3dNode metadata;
    int integerKey;
    IntegerTrigger() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderIntegerTrigger != null)
            X3dSceneGraph.callbackRenderIntegerTrigger.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataIntegerTrigger != null)
            X3dSceneGraph.callbackDoWithDataIntegerTrigger.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class IntegerTriggerRenderCallback extends RenderCallback {}
class IntegerTriggerDoWithDataCallback extends DoWithDataCallback {};


class DirectionalLight extends X3dNode {
    X3dNode metadata;
    float ambientIntensity;
    float[] color;
    int color_length;
    float[] direction;
    int direction_length;
    float intensity;
    boolean on;
    boolean kambiShadows;
    boolean kambiShadowsMain;
    DirectionalLight() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderDirectionalLight != null)
            X3dSceneGraph.callbackRenderDirectionalLight.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataDirectionalLight != null)
            X3dSceneGraph.callbackDoWithDataDirectionalLight.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class DirectionalLightRenderCallback extends RenderCallback {}
class DirectionalLightDoWithDataCallback extends DoWithDataCallback {};


class GeoLOD extends X3dNode {
    X3dNode metadata;
    X3dNode geoOrigin;
    String[] geoSystem;
    int geoSystem_length;
    X3dNode [] children;
    int children_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    double[] center;
    int center_length;
    String[] child1Url;
    int child1Url_length;
    String[] child2Url;
    int child2Url_length;
    String[] child3Url;
    int child3Url_length;
    String[] child4Url;
    int child4Url_length;
    float[] range;
    int range_length;
    String[] rootUrl;
    int rootUrl_length;
    X3dNode [] rootNode;
    int rootNode_length;
    GeoLOD() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderGeoLOD != null)
            X3dSceneGraph.callbackRenderGeoLOD.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (geoOrigin != null)
            geoOrigin.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
        for (int i = 0; i < rootNode_length; i++)
            if (rootNode[i] != null)
                rootNode[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataGeoLOD != null)
            X3dSceneGraph.callbackDoWithDataGeoLOD.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (geoOrigin != null)
            geoOrigin.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
        for (int i = 0; i < rootNode_length; i++)
            if (rootNode[i] != null)
                rootNode[i].treeDoWithData();
    }
}

class GeoLODRenderCallback extends RenderCallback {}
class GeoLODDoWithDataCallback extends DoWithDataCallback {};


class LdrawDatExport extends X3dNode {
    X3dNode metadata;
    String partDescription;
    String author;
    String fileType;
    String license;
    String bfc;
    String[] help;
    int help_length;
    String category;
    String[] keywords;
    int keywords_length;
    String cmdline;
    String[] history;
    int history_length;
    String[] commands;
    int commands_length;
    LdrawDatExport() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderLdrawDatExport != null)
            X3dSceneGraph.callbackRenderLdrawDatExport.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataLdrawDatExport != null)
            X3dSceneGraph.callbackDoWithDataLdrawDatExport.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class LdrawDatExportRenderCallback extends RenderCallback {}
class LdrawDatExportDoWithDataCallback extends DoWithDataCallback {};


class LOD extends X3dNode {
    X3dNode metadata;
    X3dNode [] children;
    int children_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    float[] center;
    int center_length;
    float[] range;
    int range_length;
    LOD() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderLOD != null)
            X3dSceneGraph.callbackRenderLOD.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataLOD != null)
            X3dSceneGraph.callbackDoWithDataLOD.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
    }
}

class LODRenderCallback extends RenderCallback {}
class LODDoWithDataCallback extends DoWithDataCallback {};


class MetadataSet extends X3dNode {
    X3dNode metadata;
    String name;
    String reference;
    X3dNode [] value;
    int value_length;
    MetadataSet() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderMetadataSet != null)
            X3dSceneGraph.callbackRenderMetadataSet.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < value_length; i++)
            if (value[i] != null)
                value[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataMetadataSet != null)
            X3dSceneGraph.callbackDoWithDataMetadataSet.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < value_length; i++)
            if (value[i] != null)
                value[i].treeDoWithData();
    }
}

class MetadataSetRenderCallback extends RenderCallback {}
class MetadataSetDoWithDataCallback extends DoWithDataCallback {};


class OdeSingleAxisHingeJoint extends X3dNode {
    X3dNode metadata;
    X3dNode body1;
    X3dNode body2;
    String[] forceOutput;
    int forceOutput_length;
    float[] anchorPoint;
    int anchorPoint_length;
    float[] axis;
    int axis_length;
    float maxAngle;
    float minAngle;
    float stopBounce;
    float stopErrorCorrection;
    float fMax;
    OdeSingleAxisHingeJoint() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderOdeSingleAxisHingeJoint != null)
            X3dSceneGraph.callbackRenderOdeSingleAxisHingeJoint.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (body1 != null)
            body1.treeRender();
        if (body2 != null)
            body2.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataOdeSingleAxisHingeJoint != null)
            X3dSceneGraph.callbackDoWithDataOdeSingleAxisHingeJoint.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (body1 != null)
            body1.treeDoWithData();
        if (body2 != null)
            body2.treeDoWithData();
    }
}

class OdeSingleAxisHingeJointRenderCallback extends RenderCallback {}
class OdeSingleAxisHingeJointDoWithDataCallback extends DoWithDataCallback {};


class PointSet extends X3dNode {
    X3dNode metadata;
    X3dNode color;
    X3dNode coord;
    PointSet() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderPointSet != null)
            X3dSceneGraph.callbackRenderPointSet.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (color != null)
            color.treeRender();
        if (coord != null)
            coord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataPointSet != null)
            X3dSceneGraph.callbackDoWithDataPointSet.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (color != null)
            color.treeDoWithData();
        if (coord != null)
            coord.treeDoWithData();
    }
}

class PointSetRenderCallback extends RenderCallback {}
class PointSetDoWithDataCallback extends DoWithDataCallback {};


class SingleAxisHingeJoint extends X3dNode {
    X3dNode metadata;
    X3dNode body1;
    X3dNode body2;
    String[] forceOutput;
    int forceOutput_length;
    float[] anchorPoint;
    int anchorPoint_length;
    float[] axis;
    int axis_length;
    float maxAngle;
    float minAngle;
    float stopBounce;
    float stopErrorCorrection;
    SingleAxisHingeJoint() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderSingleAxisHingeJoint != null)
            X3dSceneGraph.callbackRenderSingleAxisHingeJoint.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (body1 != null)
            body1.treeRender();
        if (body2 != null)
            body2.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataSingleAxisHingeJoint != null)
            X3dSceneGraph.callbackDoWithDataSingleAxisHingeJoint.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (body1 != null)
            body1.treeDoWithData();
        if (body2 != null)
            body2.treeDoWithData();
    }
}

class SingleAxisHingeJointRenderCallback extends RenderCallback {}
class SingleAxisHingeJointDoWithDataCallback extends DoWithDataCallback {};


class MetadataDouble extends X3dNode {
    X3dNode metadata;
    String name;
    String reference;
    double[] value;
    int value_length;
    MetadataDouble() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderMetadataDouble != null)
            X3dSceneGraph.callbackRenderMetadataDouble.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataMetadataDouble != null)
            X3dSceneGraph.callbackDoWithDataMetadataDouble.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class MetadataDoubleRenderCallback extends RenderCallback {}
class MetadataDoubleDoWithDataCallback extends DoWithDataCallback {};


class TrimmedSurface extends X3dNode {
    X3dNode metadata;
    X3dNode [] trimmingContour;
    int trimmingContour_length;
    X3dNode surface;
    TrimmedSurface() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderTrimmedSurface != null)
            X3dSceneGraph.callbackRenderTrimmedSurface.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < trimmingContour_length; i++)
            if (trimmingContour[i] != null)
                trimmingContour[i].treeRender();
        if (surface != null)
            surface.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataTrimmedSurface != null)
            X3dSceneGraph.callbackDoWithDataTrimmedSurface.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < trimmingContour_length; i++)
            if (trimmingContour[i] != null)
                trimmingContour[i].treeDoWithData();
        if (surface != null)
            surface.treeDoWithData();
    }
}

class TrimmedSurfaceRenderCallback extends RenderCallback {}
class TrimmedSurfaceDoWithDataCallback extends DoWithDataCallback {};


class Collision extends X3dNode {
    X3dNode metadata;
    X3dNode [] children;
    int children_length;
    boolean enabled;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    X3dNode proxy;
    Collision() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCollision != null)
            X3dSceneGraph.callbackRenderCollision.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
        if (proxy != null)
            proxy.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCollision != null)
            X3dSceneGraph.callbackDoWithDataCollision.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
        if (proxy != null)
            proxy.treeDoWithData();
    }
}

class CollisionRenderCallback extends RenderCallback {}
class CollisionDoWithDataCallback extends DoWithDataCallback {};


class GeoOrigin extends X3dNode {
    X3dNode metadata;
    double[] geoCoords;
    int geoCoords_length;
    String[] geoSystem;
    int geoSystem_length;
    boolean rotateYUp;
    GeoOrigin() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderGeoOrigin != null)
            X3dSceneGraph.callbackRenderGeoOrigin.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataGeoOrigin != null)
            X3dSceneGraph.callbackDoWithDataGeoOrigin.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class GeoOriginRenderCallback extends RenderCallback {}
class GeoOriginDoWithDataCallback extends DoWithDataCallback {};


class Group extends X3dNode {
    X3dNode metadata;
    X3dNode [] children;
    int children_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    Group() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderGroup != null)
            X3dSceneGraph.callbackRenderGroup.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataGroup != null)
            X3dSceneGraph.callbackDoWithDataGroup.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
    }
}

class GroupRenderCallback extends RenderCallback {}
class GroupDoWithDataCallback extends DoWithDataCallback {};


class NurbsGroup extends X3dNode {
    X3dNode metadata;
    X3dNode [] children;
    int children_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    float tessellationScale;
    NurbsGroup() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNurbsGroup != null)
            X3dSceneGraph.callbackRenderNurbsGroup.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNurbsGroup != null)
            X3dSceneGraph.callbackDoWithDataNurbsGroup.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
    }
}

class NurbsGroupRenderCallback extends RenderCallback {}
class NurbsGroupDoWithDataCallback extends DoWithDataCallback {};


class CoordinateDeformer extends X3dNode {
    X3dNode metadata;
    X3dNode [] children;
    int children_length;
    X3dNode [] outputCoord;
    int outputCoord_length;
    X3dNode [] inputCoord;
    int inputCoord_length;
    float[] controlPoint;
    int controlPoint_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    float[] weight;
    int weight_length;
    int uDimension;
    int vDimension;
    int wDimension;
    float[] uKnot;
    int uKnot_length;
    float[] vKnot;
    int vKnot_length;
    float[] wKnot;
    int wKnot_length;
    int uOrder;
    int vOrder;
    int wOrder;
    CoordinateDeformer() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCoordinateDeformer != null)
            X3dSceneGraph.callbackRenderCoordinateDeformer.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
        for (int i = 0; i < outputCoord_length; i++)
            if (outputCoord[i] != null)
                outputCoord[i].treeRender();
        for (int i = 0; i < inputCoord_length; i++)
            if (inputCoord[i] != null)
                inputCoord[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCoordinateDeformer != null)
            X3dSceneGraph.callbackDoWithDataCoordinateDeformer.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
        for (int i = 0; i < outputCoord_length; i++)
            if (outputCoord[i] != null)
                outputCoord[i].treeDoWithData();
        for (int i = 0; i < inputCoord_length; i++)
            if (inputCoord[i] != null)
                inputCoord[i].treeDoWithData();
    }
}

class CoordinateDeformerRenderCallback extends RenderCallback {}
class CoordinateDeformerDoWithDataCallback extends DoWithDataCallback {};


class GeoPositionInterpolator extends X3dNode {
    X3dNode metadata;
    X3dNode geoOrigin;
    String[] geoSystem;
    int geoSystem_length;
    float[] key;
    int key_length;
    double[] keyValue;
    int keyValue_length;
    GeoPositionInterpolator() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderGeoPositionInterpolator != null)
            X3dSceneGraph.callbackRenderGeoPositionInterpolator.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (geoOrigin != null)
            geoOrigin.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataGeoPositionInterpolator != null)
            X3dSceneGraph.callbackDoWithDataGeoPositionInterpolator.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (geoOrigin != null)
            geoOrigin.treeDoWithData();
    }
}

class GeoPositionInterpolatorRenderCallback extends RenderCallback {}
class GeoPositionInterpolatorDoWithDataCallback extends DoWithDataCallback {};


class PositionInterpolator extends X3dNode {
    X3dNode metadata;
    float[] key;
    int key_length;
    float[] keyValue;
    int keyValue_length;
    PositionInterpolator() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderPositionInterpolator != null)
            X3dSceneGraph.callbackRenderPositionInterpolator.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataPositionInterpolator != null)
            X3dSceneGraph.callbackDoWithDataPositionInterpolator.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class PositionInterpolatorRenderCallback extends RenderCallback {}
class PositionInterpolatorDoWithDataCallback extends DoWithDataCallback {};


class ProximitySensor extends X3dNode {
    X3dNode metadata;
    float[] center;
    int center_length;
    boolean enabled;
    float[] size;
    int size_length;
    ProximitySensor() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderProximitySensor != null)
            X3dSceneGraph.callbackRenderProximitySensor.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataProximitySensor != null)
            X3dSceneGraph.callbackDoWithDataProximitySensor.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class ProximitySensorRenderCallback extends RenderCallback {}
class ProximitySensorDoWithDataCallback extends DoWithDataCallback {};


class VisibilitySensor extends X3dNode {
    X3dNode metadata;
    float[] center;
    int center_length;
    boolean enabled;
    float[] size;
    int size_length;
    VisibilitySensor() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderVisibilitySensor != null)
            X3dSceneGraph.callbackRenderVisibilitySensor.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataVisibilitySensor != null)
            X3dSceneGraph.callbackDoWithDataVisibilitySensor.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class VisibilitySensorRenderCallback extends RenderCallback {}
class VisibilitySensorDoWithDataCallback extends DoWithDataCallback {};


class CattExportSrc extends X3dNode {
    X3dNode metadata;
    String id;
    float[] sourceCenterLocation;
    int sourceCenterLocation_length;
    String sourceDirectivityName;
    float[] coordinateToAimTheSource;
    int coordinateToAimTheSource_length;
    float roll;
    String[] furtherParameters;
    int furtherParameters_length;
    CattExportSrc() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCattExportSrc != null)
            X3dSceneGraph.callbackRenderCattExportSrc.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCattExportSrc != null)
            X3dSceneGraph.callbackDoWithDataCattExportSrc.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class CattExportSrcRenderCallback extends RenderCallback {}
class CattExportSrcDoWithDataCallback extends DoWithDataCallback {};


class Circle2D extends X3dNode {
    X3dNode metadata;
    float radius;
    Circle2D() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCircle2D != null)
            X3dSceneGraph.callbackRenderCircle2D.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCircle2D != null)
            X3dSceneGraph.callbackDoWithDataCircle2D.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class Circle2DRenderCallback extends RenderCallback {}
class Circle2DDoWithDataCallback extends DoWithDataCallback {};


class HAnimHumanoid extends X3dNode {
    X3dNode metadata;
    float[] rotation;
    int rotation_length;
    float[] translation;
    int translation_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    float[] center;
    int center_length;
    float[] scale;
    int scale_length;
    float[] scaleOrientation;
    int scaleOrientation_length;
    String[] info;
    int info_length;
    X3dNode [] joints;
    int joints_length;
    String name;
    X3dNode [] segments;
    int segments_length;
    X3dNode [] sites;
    int sites_length;
    X3dNode [] skeleton;
    int skeleton_length;
    X3dNode [] skin;
    int skin_length;
    X3dNode skinCoord;
    X3dNode skinNormal;
    String version;
    X3dNode [] viewpoints;
    int viewpoints_length;
    HAnimHumanoid() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderHAnimHumanoid != null)
            X3dSceneGraph.callbackRenderHAnimHumanoid.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < joints_length; i++)
            if (joints[i] != null)
                joints[i].treeRender();
        for (int i = 0; i < segments_length; i++)
            if (segments[i] != null)
                segments[i].treeRender();
        for (int i = 0; i < sites_length; i++)
            if (sites[i] != null)
                sites[i].treeRender();
        for (int i = 0; i < skeleton_length; i++)
            if (skeleton[i] != null)
                skeleton[i].treeRender();
        for (int i = 0; i < skin_length; i++)
            if (skin[i] != null)
                skin[i].treeRender();
        if (skinCoord != null)
            skinCoord.treeRender();
        if (skinNormal != null)
            skinNormal.treeRender();
        for (int i = 0; i < viewpoints_length; i++)
            if (viewpoints[i] != null)
                viewpoints[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataHAnimHumanoid != null)
            X3dSceneGraph.callbackDoWithDataHAnimHumanoid.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < joints_length; i++)
            if (joints[i] != null)
                joints[i].treeDoWithData();
        for (int i = 0; i < segments_length; i++)
            if (segments[i] != null)
                segments[i].treeDoWithData();
        for (int i = 0; i < sites_length; i++)
            if (sites[i] != null)
                sites[i].treeDoWithData();
        for (int i = 0; i < skeleton_length; i++)
            if (skeleton[i] != null)
                skeleton[i].treeDoWithData();
        for (int i = 0; i < skin_length; i++)
            if (skin[i] != null)
                skin[i].treeDoWithData();
        if (skinCoord != null)
            skinCoord.treeDoWithData();
        if (skinNormal != null)
            skinNormal.treeDoWithData();
        for (int i = 0; i < viewpoints_length; i++)
            if (viewpoints[i] != null)
                viewpoints[i].treeDoWithData();
    }
}

class HAnimHumanoidRenderCallback extends RenderCallback {}
class HAnimHumanoidDoWithDataCallback extends DoWithDataCallback {};


class IndexedFaceSet extends X3dNode {
    X3dNode metadata;
    X3dNode color;
    X3dNode coord;
    X3dNode normal;
    X3dNode texCoord;
    boolean ccw;
    int[] colorIndex;
    int colorIndex_length;
    boolean colorPerVertex;
    boolean convex;
    int[] coordIndex;
    int coordIndex_length;
    float creaseAngle;
    int[] normalIndex;
    int normalIndex_length;
    boolean normalPerVertex;
    boolean solid;
    int[] texCoordIndex;
    int texCoordIndex_length;
    IndexedFaceSet() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderIndexedFaceSet != null)
            X3dSceneGraph.callbackRenderIndexedFaceSet.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (color != null)
            color.treeRender();
        if (coord != null)
            coord.treeRender();
        if (normal != null)
            normal.treeRender();
        if (texCoord != null)
            texCoord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataIndexedFaceSet != null)
            X3dSceneGraph.callbackDoWithDataIndexedFaceSet.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (color != null)
            color.treeDoWithData();
        if (coord != null)
            coord.treeDoWithData();
        if (normal != null)
            normal.treeDoWithData();
        if (texCoord != null)
            texCoord.treeDoWithData();
    }
}

class IndexedFaceSetRenderCallback extends RenderCallback {}
class IndexedFaceSetDoWithDataCallback extends DoWithDataCallback {};


class Rectangle2D extends X3dNode {
    X3dNode metadata;
    float[] size;
    int size_length;
    boolean solid;
    Rectangle2D() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderRectangle2D != null)
            X3dSceneGraph.callbackRenderRectangle2D.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataRectangle2D != null)
            X3dSceneGraph.callbackDoWithDataRectangle2D.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class Rectangle2DRenderCallback extends RenderCallback {}
class Rectangle2DDoWithDataCallback extends DoWithDataCallback {};


class Sound extends X3dNode {
    X3dNode metadata;
    float[] direction;
    int direction_length;
    float intensity;
    float[] location;
    int location_length;
    float maxBack;
    float maxFront;
    float minBack;
    float minFront;
    float priority;
    X3dNode source;
    boolean spatialize;
    Sound() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderSound != null)
            X3dSceneGraph.callbackRenderSound.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (source != null)
            source.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataSound != null)
            X3dSceneGraph.callbackDoWithDataSound.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (source != null)
            source.treeDoWithData();
    }
}

class SoundRenderCallback extends RenderCallback {}
class SoundDoWithDataCallback extends DoWithDataCallback {};


class TriangleSet extends X3dNode {
    X3dNode metadata;
    X3dNode color;
    X3dNode coord;
    X3dNode normal;
    X3dNode texCoord;
    boolean ccw;
    boolean colorPerVertex;
    boolean normalPerVertex;
    boolean solid;
    TriangleSet() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderTriangleSet != null)
            X3dSceneGraph.callbackRenderTriangleSet.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (color != null)
            color.treeRender();
        if (coord != null)
            coord.treeRender();
        if (normal != null)
            normal.treeRender();
        if (texCoord != null)
            texCoord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataTriangleSet != null)
            X3dSceneGraph.callbackDoWithDataTriangleSet.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (color != null)
            color.treeDoWithData();
        if (coord != null)
            coord.treeDoWithData();
        if (normal != null)
            normal.treeDoWithData();
        if (texCoord != null)
            texCoord.treeDoWithData();
    }
}

class TriangleSetRenderCallback extends RenderCallback {}
class TriangleSetDoWithDataCallback extends DoWithDataCallback {};


class Cone extends X3dNode {
    X3dNode metadata;
    boolean bottom;
    float bottomRadius;
    float height;
    boolean side;
    boolean solid;
    Cone() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCone != null)
            X3dSceneGraph.callbackRenderCone.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCone != null)
            X3dSceneGraph.callbackDoWithDataCone.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class ConeRenderCallback extends RenderCallback {}
class ConeDoWithDataCallback extends DoWithDataCallback {};


class Coordinate extends X3dNode {
    X3dNode metadata;
    float[] point;
    int point_length;
    Coordinate() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCoordinate != null)
            X3dSceneGraph.callbackRenderCoordinate.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCoordinate != null)
            X3dSceneGraph.callbackDoWithDataCoordinate.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class CoordinateRenderCallback extends RenderCallback {}
class CoordinateDoWithDataCallback extends DoWithDataCallback {};


class FontStyle extends X3dNode {
    X3dNode metadata;
    String[] family;
    int family_length;
    boolean horizontal;
    String[] justify;
    int justify_length;
    String language;
    boolean leftToRight;
    float size;
    float spacing;
    String style;
    boolean topToBottom;
    FontStyle() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderFontStyle != null)
            X3dSceneGraph.callbackRenderFontStyle.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataFontStyle != null)
            X3dSceneGraph.callbackDoWithDataFontStyle.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class FontStyleRenderCallback extends RenderCallback {}
class FontStyleDoWithDataCallback extends DoWithDataCallback {};


class Inline extends X3dNode {
    X3dNode metadata;
    boolean load;
    String[] url;
    int url_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    Inline() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderInline != null)
            X3dSceneGraph.callbackRenderInline.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataInline != null)
            X3dSceneGraph.callbackDoWithDataInline.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class InlineRenderCallback extends RenderCallback {}
class InlineDoWithDataCallback extends DoWithDataCallback {};


class MultiTextureCoordinate extends X3dNode {
    X3dNode metadata;
    X3dNode [] texCoord;
    int texCoord_length;
    MultiTextureCoordinate() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderMultiTextureCoordinate != null)
            X3dSceneGraph.callbackRenderMultiTextureCoordinate.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < texCoord_length; i++)
            if (texCoord[i] != null)
                texCoord[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataMultiTextureCoordinate != null)
            X3dSceneGraph.callbackDoWithDataMultiTextureCoordinate.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < texCoord_length; i++)
            if (texCoord[i] != null)
                texCoord[i].treeDoWithData();
    }
}

class MultiTextureCoordinateRenderCallback extends RenderCallback {}
class MultiTextureCoordinateDoWithDataCallback extends DoWithDataCallback {};


class NurbsCurve extends X3dNode {
    X3dNode metadata;
    X3dNode controlPoint;
    int tessellation;
    float[] weight;
    int weight_length;
    boolean closed;
    float[] knot;
    int knot_length;
    int order;
    NurbsCurve() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNurbsCurve != null)
            X3dSceneGraph.callbackRenderNurbsCurve.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (controlPoint != null)
            controlPoint.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNurbsCurve != null)
            X3dSceneGraph.callbackDoWithDataNurbsCurve.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (controlPoint != null)
            controlPoint.treeDoWithData();
    }
}

class NurbsCurveRenderCallback extends RenderCallback {}
class NurbsCurveDoWithDataCallback extends DoWithDataCallback {};


class NurbsSwungSurface extends X3dNode {
    X3dNode metadata;
    X3dNode profileCurve;
    X3dNode trajectoryCurve;
    boolean ccw;
    boolean solid;
    NurbsSwungSurface() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNurbsSwungSurface != null)
            X3dSceneGraph.callbackRenderNurbsSwungSurface.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (profileCurve != null)
            profileCurve.treeRender();
        if (trajectoryCurve != null)
            trajectoryCurve.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNurbsSwungSurface != null)
            X3dSceneGraph.callbackDoWithDataNurbsSwungSurface.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (profileCurve != null)
            profileCurve.treeDoWithData();
        if (trajectoryCurve != null)
            trajectoryCurve.treeDoWithData();
    }
}

class NurbsSwungSurfaceRenderCallback extends RenderCallback {}
class NurbsSwungSurfaceDoWithDataCallback extends DoWithDataCallback {};


class NurbsTextureSurface extends X3dNode {
    X3dNode metadata;
    int uDimension;
    int vDimension;
    float[] uKnot;
    int uKnot_length;
    float[] vKnot;
    int vKnot_length;
    int uOrder;
    int vOrder;
    float[] controlPoint;
    int controlPoint_length;
    float[] weight;
    int weight_length;
    int uTessellation;
    int vTessellation;
    NurbsTextureSurface() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNurbsTextureSurface != null)
            X3dSceneGraph.callbackRenderNurbsTextureSurface.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNurbsTextureSurface != null)
            X3dSceneGraph.callbackDoWithDataNurbsTextureSurface.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class NurbsTextureSurfaceRenderCallback extends RenderCallback {}
class NurbsTextureSurfaceDoWithDataCallback extends DoWithDataCallback {};


class SignalPdu extends X3dNode {
    X3dNode metadata;
    int[] data;
    int data_length;
    int dataLength;
    int encodingScheme;
    int radioID;
    int sampleRate;
    int samples;
    int tdlType;
    int whichGeometry;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    String networkMode;
    double readInterval;
    double writeInterval;
    int siteID;
    int applicationID;
    int entityID;
    String address;
    int port;
    String multicastRelayHost;
    int multicastRelayPort;
    boolean rtpHeaderExpected;
    SignalPdu() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderSignalPdu != null)
            X3dSceneGraph.callbackRenderSignalPdu.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataSignalPdu != null)
            X3dSceneGraph.callbackDoWithDataSignalPdu.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class SignalPduRenderCallback extends RenderCallback {}
class SignalPduDoWithDataCallback extends DoWithDataCallback {};


class RigidBody extends X3dNode {
    X3dNode metadata;
    float angularDampingFactor;
    float[] angularVelocity;
    int angularVelocity_length;
    boolean autoDamp;
    boolean autoDisable;
    float[] centerOfMass;
    int centerOfMass_length;
    float disableAngularSpeed;
    float disableLinearSpeed;
    float disableTime;
    boolean enabled;
    float[] finiteRotationAxis;
    int finiteRotationAxis_length;
    boolean fixed;
    float[] forces;
    int forces_length;
    X3dNode [] geometry;
    int geometry_length;
    float[] inertia;
    int inertia_length;
    float linearDampingFactor;
    float[] linearVelocity;
    int linearVelocity_length;
    float mass;
    X3dNode massDensityModel;
    float[] orientation;
    int orientation_length;
    float[] position;
    int position_length;
    float[] torques;
    int torques_length;
    boolean useFiniteRotation;
    boolean useGlobalGravity;
    RigidBody() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderRigidBody != null)
            X3dSceneGraph.callbackRenderRigidBody.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < geometry_length; i++)
            if (geometry[i] != null)
                geometry[i].treeRender();
        if (massDensityModel != null)
            massDensityModel.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataRigidBody != null)
            X3dSceneGraph.callbackDoWithDataRigidBody.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < geometry_length; i++)
            if (geometry[i] != null)
                geometry[i].treeDoWithData();
        if (massDensityModel != null)
            massDensityModel.treeDoWithData();
    }
}

class RigidBodyRenderCallback extends RenderCallback {}
class RigidBodyDoWithDataCallback extends DoWithDataCallback {};


class Material extends X3dNode {
    X3dNode metadata;
    float ambientIntensity;
    float[] diffuseColor;
    int diffuseColor_length;
    float[] emissiveColor;
    int emissiveColor_length;
    float shininess;
    float[] specularColor;
    int specularColor_length;
    float transparency;
    boolean fogImmune;
    float mirror;
    Material() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderMaterial != null)
            X3dSceneGraph.callbackRenderMaterial.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataMaterial != null)
            X3dSceneGraph.callbackDoWithDataMaterial.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class MaterialRenderCallback extends RenderCallback {}
class MaterialDoWithDataCallback extends DoWithDataCallback {};


class EspduTransform extends X3dNode {
    X3dNode metadata;
    float[] rotation;
    int rotation_length;
    float[] translation;
    int translation_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    float[] center;
    int center_length;
    float[] scale;
    int scale_length;
    float[] scaleOrientation;
    int scaleOrientation_length;
    X3dNode [] children;
    int children_length;
    int articulationParameterCount;
    int[] articulationParameterDesignatorArray;
    int articulationParameterDesignatorArray_length;
    int[] articulationParameterChangeIndicatorArray;
    int articulationParameterChangeIndicatorArray_length;
    int[] articulationParameterIdPartAttachedToArray;
    int articulationParameterIdPartAttachedToArray_length;
    int[] articulationParameterTypeArray;
    int articulationParameterTypeArray_length;
    float[] articulationParameterArray;
    int articulationParameterArray_length;
    int collisionType;
    int deadReckoning;
    float[] detonationLocation;
    int detonationLocation_length;
    float[] detonationRelativeLocation;
    int detonationRelativeLocation_length;
    int detonationResult;
    int entityCategory;
    int entityCountry;
    int entityDomain;
    int entityExtra;
    int entityKind;
    int entitySpecific;
    int eventApplicationID;
    int eventEntityID;
    int eventNumber;
    int eventSiteID;
    boolean fired1;
    boolean fired2;
    int fireMissionIndex;
    float firingRange;
    int firingRate;
    int forceID;
    int fuse;
    float[] linearVelocity;
    int linearVelocity_length;
    float[] linearAcceleration;
    int linearAcceleration_length;
    String marking;
    int munitionApplicationID;
    float[] munitionEndPoint;
    int munitionEndPoint_length;
    int munitionEntityID;
    int munitionQuantity;
    int munitionSiteID;
    float[] munitionStartPoint;
    int munitionStartPoint_length;
    int warhead;
    String networkMode;
    double readInterval;
    double writeInterval;
    int siteID;
    int applicationID;
    int entityID;
    String address;
    int port;
    String multicastRelayHost;
    int multicastRelayPort;
    boolean rtpHeaderExpected;
    EspduTransform() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderEspduTransform != null)
            X3dSceneGraph.callbackRenderEspduTransform.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataEspduTransform != null)
            X3dSceneGraph.callbackDoWithDataEspduTransform.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
    }
}

class EspduTransformRenderCallback extends RenderCallback {}
class EspduTransformDoWithDataCallback extends DoWithDataCallback {};


class MultiTextureTransform extends X3dNode {
    X3dNode metadata;
    X3dNode [] textureTransform;
    int textureTransform_length;
    MultiTextureTransform() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderMultiTextureTransform != null)
            X3dSceneGraph.callbackRenderMultiTextureTransform.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < textureTransform_length; i++)
            if (textureTransform[i] != null)
                textureTransform[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataMultiTextureTransform != null)
            X3dSceneGraph.callbackDoWithDataMultiTextureTransform.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < textureTransform_length; i++)
            if (textureTransform[i] != null)
                textureTransform[i].treeDoWithData();
    }
}

class MultiTextureTransformRenderCallback extends RenderCallback {}
class MultiTextureTransformDoWithDataCallback extends DoWithDataCallback {};


class MetadataInteger extends X3dNode {
    X3dNode metadata;
    String name;
    String reference;
    int[] value;
    int value_length;
    MetadataInteger() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderMetadataInteger != null)
            X3dSceneGraph.callbackRenderMetadataInteger.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataMetadataInteger != null)
            X3dSceneGraph.callbackDoWithDataMetadataInteger.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class MetadataIntegerRenderCallback extends RenderCallback {}
class MetadataIntegerDoWithDataCallback extends DoWithDataCallback {};


class NurbsOrientationInterpolator extends X3dNode {
    X3dNode metadata;
    X3dNode controlPoints;
    double[] knot;
    int knot_length;
    int order;
    double[] weight;
    int weight_length;
    NurbsOrientationInterpolator() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNurbsOrientationInterpolator != null)
            X3dSceneGraph.callbackRenderNurbsOrientationInterpolator.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (controlPoints != null)
            controlPoints.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNurbsOrientationInterpolator != null)
            X3dSceneGraph.callbackDoWithDataNurbsOrientationInterpolator.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (controlPoints != null)
            controlPoints.treeDoWithData();
    }
}

class NurbsOrientationInterpolatorRenderCallback extends RenderCallback {}
class NurbsOrientationInterpolatorDoWithDataCallback extends DoWithDataCallback {};


class NurbsPositionInterpolator extends X3dNode {
    X3dNode metadata;
    float[] keyValue;
    int keyValue_length;
    float[] keyWeight;
    int keyWeight_length;
    float[] knot;
    int knot_length;
    int order;
    NurbsPositionInterpolator() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNurbsPositionInterpolator != null)
            X3dSceneGraph.callbackRenderNurbsPositionInterpolator.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNurbsPositionInterpolator != null)
            X3dSceneGraph.callbackDoWithDataNurbsPositionInterpolator.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class NurbsPositionInterpolatorRenderCallback extends RenderCallback {}
class NurbsPositionInterpolatorDoWithDataCallback extends DoWithDataCallback {};


class OrientationInterpolator extends X3dNode {
    X3dNode metadata;
    float[] key;
    int key_length;
    float[] keyValue;
    int keyValue_length;
    OrientationInterpolator() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderOrientationInterpolator != null)
            X3dSceneGraph.callbackRenderOrientationInterpolator.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataOrientationInterpolator != null)
            X3dSceneGraph.callbackDoWithDataOrientationInterpolator.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class OrientationInterpolatorRenderCallback extends RenderCallback {}
class OrientationInterpolatorDoWithDataCallback extends DoWithDataCallback {};


class TimeSensor extends X3dNode {
    X3dNode metadata;
    double cycleInterval;
    boolean enabled;
    boolean loop;
    double pauseTime;
    double resumeTime;
    double startTime;
    double stopTime;
    TimeSensor() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderTimeSensor != null)
            X3dSceneGraph.callbackRenderTimeSensor.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataTimeSensor != null)
            X3dSceneGraph.callbackDoWithDataTimeSensor.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class TimeSensorRenderCallback extends RenderCallback {}
class TimeSensorDoWithDataCallback extends DoWithDataCallback {};


class BallJoint extends X3dNode {
    X3dNode metadata;
    X3dNode body1;
    X3dNode body2;
    String[] forceOutput;
    int forceOutput_length;
    float[] anchorPoint;
    int anchorPoint_length;
    BallJoint() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderBallJoint != null)
            X3dSceneGraph.callbackRenderBallJoint.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (body1 != null)
            body1.treeRender();
        if (body2 != null)
            body2.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataBallJoint != null)
            X3dSceneGraph.callbackDoWithDataBallJoint.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (body1 != null)
            body1.treeDoWithData();
        if (body2 != null)
            body2.treeDoWithData();
    }
}

class BallJointRenderCallback extends RenderCallback {}
class BallJointDoWithDataCallback extends DoWithDataCallback {};


class CollidableOffset extends X3dNode {
    X3dNode metadata;
    boolean enabled;
    float[] rotation;
    int rotation_length;
    float[] translation;
    int translation_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    X3dNode collidable;
    CollidableOffset() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCollidableOffset != null)
            X3dSceneGraph.callbackRenderCollidableOffset.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (collidable != null)
            collidable.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCollidableOffset != null)
            X3dSceneGraph.callbackDoWithDataCollidableOffset.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (collidable != null)
            collidable.treeDoWithData();
    }
}

class CollidableOffsetRenderCallback extends RenderCallback {}
class CollidableOffsetDoWithDataCallback extends DoWithDataCallback {};


class IndexedLineSet extends X3dNode {
    X3dNode metadata;
    X3dNode color;
    X3dNode coord;
    int[] colorIndex;
    int colorIndex_length;
    boolean colorPerVertex;
    int[] coordIndex;
    int coordIndex_length;
    IndexedLineSet() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderIndexedLineSet != null)
            X3dSceneGraph.callbackRenderIndexedLineSet.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (color != null)
            color.treeRender();
        if (coord != null)
            coord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataIndexedLineSet != null)
            X3dSceneGraph.callbackDoWithDataIndexedLineSet.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (color != null)
            color.treeDoWithData();
        if (coord != null)
            coord.treeDoWithData();
    }
}

class IndexedLineSetRenderCallback extends RenderCallback {}
class IndexedLineSetDoWithDataCallback extends DoWithDataCallback {};


class IndexedTriangleStripSet extends X3dNode {
    X3dNode metadata;
    X3dNode color;
    X3dNode coord;
    X3dNode normal;
    X3dNode texCoord;
    boolean ccw;
    boolean normalPerVertex;
    boolean solid;
    int[] index;
    int index_length;
    float creaseAngle;
    IndexedTriangleStripSet() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderIndexedTriangleStripSet != null)
            X3dSceneGraph.callbackRenderIndexedTriangleStripSet.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (color != null)
            color.treeRender();
        if (coord != null)
            coord.treeRender();
        if (normal != null)
            normal.treeRender();
        if (texCoord != null)
            texCoord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataIndexedTriangleStripSet != null)
            X3dSceneGraph.callbackDoWithDataIndexedTriangleStripSet.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (color != null)
            color.treeDoWithData();
        if (coord != null)
            coord.treeDoWithData();
        if (normal != null)
            normal.treeDoWithData();
        if (texCoord != null)
            texCoord.treeDoWithData();
    }
}

class IndexedTriangleStripSetRenderCallback extends RenderCallback {}
class IndexedTriangleStripSetDoWithDataCallback extends DoWithDataCallback {};


class MetadataFloat extends X3dNode {
    X3dNode metadata;
    String name;
    String reference;
    float[] value;
    int value_length;
    MetadataFloat() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderMetadataFloat != null)
            X3dSceneGraph.callbackRenderMetadataFloat.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataMetadataFloat != null)
            X3dSceneGraph.callbackDoWithDataMetadataFloat.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class MetadataFloatRenderCallback extends RenderCallback {}
class MetadataFloatDoWithDataCallback extends DoWithDataCallback {};


class OdeMotorJoint extends X3dNode {
    X3dNode metadata;
    X3dNode body1;
    X3dNode body2;
    String[] forceOutput;
    int forceOutput_length;
    float axis1Angle;
    float axis1Torque;
    float axis2Angle;
    float axis2Torque;
    float axis3Angle;
    float axis3Torque;
    int enabledAxes;
    float[] motor1Axis;
    int motor1Axis_length;
    float[] motor2Axis;
    int motor2Axis_length;
    float[] motor3Axis;
    int motor3Axis_length;
    float stop1Bounce;
    float stop1ErrorCorrection;
    float stop2Bounce;
    float stop2ErrorCorrection;
    float stop3Bounce;
    float stop3ErrorCorrection;
    boolean autoCalc;
    float fMax1;
    float fMax2;
    float fMax3;
    OdeMotorJoint() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderOdeMotorJoint != null)
            X3dSceneGraph.callbackRenderOdeMotorJoint.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (body1 != null)
            body1.treeRender();
        if (body2 != null)
            body2.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataOdeMotorJoint != null)
            X3dSceneGraph.callbackDoWithDataOdeMotorJoint.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (body1 != null)
            body1.treeDoWithData();
        if (body2 != null)
            body2.treeDoWithData();
    }
}

class OdeMotorJointRenderCallback extends RenderCallback {}
class OdeMotorJointDoWithDataCallback extends DoWithDataCallback {};


class TriangleFanSet extends X3dNode {
    X3dNode metadata;
    X3dNode color;
    X3dNode coord;
    int[] fanCount;
    int fanCount_length;
    X3dNode normal;
    X3dNode texCoord;
    boolean ccw;
    boolean colorPerVertex;
    boolean normalPerVertex;
    boolean solid;
    TriangleFanSet() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderTriangleFanSet != null)
            X3dSceneGraph.callbackRenderTriangleFanSet.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (color != null)
            color.treeRender();
        if (coord != null)
            coord.treeRender();
        if (normal != null)
            normal.treeRender();
        if (texCoord != null)
            texCoord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataTriangleFanSet != null)
            X3dSceneGraph.callbackDoWithDataTriangleFanSet.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (color != null)
            color.treeDoWithData();
        if (coord != null)
            coord.treeDoWithData();
        if (normal != null)
            normal.treeDoWithData();
        if (texCoord != null)
            texCoord.treeDoWithData();
    }
}

class TriangleFanSetRenderCallback extends RenderCallback {}
class TriangleFanSetDoWithDataCallback extends DoWithDataCallback {};


class VrmlScene extends X3dNode {
    X3dNode metadata;
    X3dNode [] children;
    int children_length;
    VrmlScene() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderVrmlScene != null)
            X3dSceneGraph.callbackRenderVrmlScene.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataVrmlScene != null)
            X3dSceneGraph.callbackDoWithDataVrmlScene.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
    }
}

class VrmlSceneRenderCallback extends RenderCallback {}
class VrmlSceneDoWithDataCallback extends DoWithDataCallback {};


class Fog extends X3dNode {
    X3dNode metadata;
    float[] color;
    int color_length;
    String fogType;
    float visibilityRange;
    boolean volumetric;
    float[] volumetricDirection;
    int volumetricDirection_length;
    float volumetricVisibilityStart;
    X3dNode alternative;
    Fog() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderFog != null)
            X3dSceneGraph.callbackRenderFog.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (alternative != null)
            alternative.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataFog != null)
            X3dSceneGraph.callbackDoWithDataFog.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (alternative != null)
            alternative.treeDoWithData();
    }
}

class FogRenderCallback extends RenderCallback {}
class FogDoWithDataCallback extends DoWithDataCallback {};


class MetadataString extends X3dNode {
    X3dNode metadata;
    String name;
    String reference;
    String[] value;
    int value_length;
    MetadataString() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderMetadataString != null)
            X3dSceneGraph.callbackRenderMetadataString.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataMetadataString != null)
            X3dSceneGraph.callbackDoWithDataMetadataString.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class MetadataStringRenderCallback extends RenderCallback {}
class MetadataStringDoWithDataCallback extends DoWithDataCallback {};


class InlineLoadControl extends X3dNode {
    X3dNode metadata;
    boolean load;
    String[] url;
    int url_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    InlineLoadControl() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderInlineLoadControl != null)
            X3dSceneGraph.callbackRenderInlineLoadControl.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataInlineLoadControl != null)
            X3dSceneGraph.callbackDoWithDataInlineLoadControl.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class InlineLoadControlRenderCallback extends RenderCallback {}
class InlineLoadControlDoWithDataCallback extends DoWithDataCallback {};


class CollisionCollection extends X3dNode {
    X3dNode metadata;
    String[] appliedParameters;
    int appliedParameters_length;
    float bounce;
    X3dNode [] collidables;
    int collidables_length;
    boolean enabled;
    float[] frictionCoefficients;
    int frictionCoefficients_length;
    float minBounceSpeed;
    float[] slipFactors;
    int slipFactors_length;
    float softnessConstantForceMix;
    float softnessErrorCorrection;
    float[] surfaceSpeed;
    int surfaceSpeed_length;
    CollisionCollection() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCollisionCollection != null)
            X3dSceneGraph.callbackRenderCollisionCollection.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < collidables_length; i++)
            if (collidables[i] != null)
                collidables[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCollisionCollection != null)
            X3dSceneGraph.callbackDoWithDataCollisionCollection.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < collidables_length; i++)
            if (collidables[i] != null)
                collidables[i].treeDoWithData();
    }
}

class CollisionCollectionRenderCallback extends RenderCallback {}
class CollisionCollectionDoWithDataCallback extends DoWithDataCallback {};


class StaticGroup extends X3dNode {
    X3dNode metadata;
    X3dNode [] children;
    int children_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    StaticGroup() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderStaticGroup != null)
            X3dSceneGraph.callbackRenderStaticGroup.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataStaticGroup != null)
            X3dSceneGraph.callbackDoWithDataStaticGroup.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
    }
}

class StaticGroupRenderCallback extends RenderCallback {}
class StaticGroupDoWithDataCallback extends DoWithDataCallback {};


class Anchor extends X3dNode {
    X3dNode metadata;
    X3dNode [] children;
    int children_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    String description;
    String[] parameter;
    int parameter_length;
    String[] url;
    int url_length;
    Anchor() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderAnchor != null)
            X3dSceneGraph.callbackRenderAnchor.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataAnchor != null)
            X3dSceneGraph.callbackDoWithDataAnchor.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
    }
}

class AnchorRenderCallback extends RenderCallback {}
class AnchorDoWithDataCallback extends DoWithDataCallback {};


class BooleanTrigger extends X3dNode {
    X3dNode metadata;
    BooleanTrigger() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderBooleanTrigger != null)
            X3dSceneGraph.callbackRenderBooleanTrigger.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataBooleanTrigger != null)
            X3dSceneGraph.callbackDoWithDataBooleanTrigger.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class BooleanTriggerRenderCallback extends RenderCallback {}
class BooleanTriggerDoWithDataCallback extends DoWithDataCallback {};


class BooleanSequencer extends X3dNode {
    X3dNode metadata;
    float[] key;
    int key_length;
    boolean[] keyValue;
    int keyValue_length;
    BooleanSequencer() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderBooleanSequencer != null)
            X3dSceneGraph.callbackRenderBooleanSequencer.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataBooleanSequencer != null)
            X3dSceneGraph.callbackDoWithDataBooleanSequencer.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class BooleanSequencerRenderCallback extends RenderCallback {}
class BooleanSequencerDoWithDataCallback extends DoWithDataCallback {};


class Color extends X3dNode {
    X3dNode metadata;
    float[] color;
    int color_length;
    Color() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderColor != null)
            X3dSceneGraph.callbackRenderColor.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataColor != null)
            X3dSceneGraph.callbackDoWithDataColor.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class ColorRenderCallback extends RenderCallback {}
class ColorDoWithDataCallback extends DoWithDataCallback {};


class NurbsSurfaceInterpolator extends X3dNode {
    X3dNode metadata;
    int uDimension;
    int vDimension;
    double[] uKnot;
    int uKnot_length;
    double[] vKnot;
    int vKnot_length;
    int uOrder;
    int vOrder;
    X3dNode controlPoint;
    double[] weight;
    int weight_length;
    NurbsSurfaceInterpolator() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNurbsSurfaceInterpolator != null)
            X3dSceneGraph.callbackRenderNurbsSurfaceInterpolator.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (controlPoint != null)
            controlPoint.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNurbsSurfaceInterpolator != null)
            X3dSceneGraph.callbackDoWithDataNurbsSurfaceInterpolator.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (controlPoint != null)
            controlPoint.treeDoWithData();
    }
}

class NurbsSurfaceInterpolatorRenderCallback extends RenderCallback {}
class NurbsSurfaceInterpolatorDoWithDataCallback extends DoWithDataCallback {};


class SphereSensor extends X3dNode {
    X3dNode metadata;
    boolean autoOffset;
    String description;
    boolean enabled;
    float[] offset;
    int offset_length;
    SphereSensor() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderSphereSensor != null)
            X3dSceneGraph.callbackRenderSphereSensor.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataSphereSensor != null)
            X3dSceneGraph.callbackDoWithDataSphereSensor.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class SphereSensorRenderCallback extends RenderCallback {}
class SphereSensorDoWithDataCallback extends DoWithDataCallback {};


class TimeTrigger extends X3dNode {
    X3dNode metadata;
    TimeTrigger() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderTimeTrigger != null)
            X3dSceneGraph.callbackRenderTimeTrigger.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataTimeTrigger != null)
            X3dSceneGraph.callbackDoWithDataTimeTrigger.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class TimeTriggerRenderCallback extends RenderCallback {}
class TimeTriggerDoWithDataCallback extends DoWithDataCallback {};


class Arc2D extends X3dNode {
    X3dNode metadata;
    float endAngle;
    float radius;
    float startAngle;
    Arc2D() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderArc2D != null)
            X3dSceneGraph.callbackRenderArc2D.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataArc2D != null)
            X3dSceneGraph.callbackDoWithDataArc2D.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class Arc2DRenderCallback extends RenderCallback {}
class Arc2DDoWithDataCallback extends DoWithDataCallback {};


class Background extends X3dNode {
    X3dNode metadata;
    float[] groundAngle;
    int groundAngle_length;
    float[] groundColor;
    int groundColor_length;
    String[] backUrl;
    int backUrl_length;
    String[] rightUrl;
    int rightUrl_length;
    String[] frontUrl;
    int frontUrl_length;
    String[] leftUrl;
    int leftUrl_length;
    String[] topUrl;
    int topUrl_length;
    String[] bottomUrl;
    int bottomUrl_length;
    float[] skyAngle;
    int skyAngle_length;
    float[] skyColor;
    int skyColor_length;
    Background() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderBackground != null)
            X3dSceneGraph.callbackRenderBackground.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataBackground != null)
            X3dSceneGraph.callbackDoWithDataBackground.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class BackgroundRenderCallback extends RenderCallback {}
class BackgroundDoWithDataCallback extends DoWithDataCallback {};


class Contact extends X3dNode {
    X3dNode metadata;
    String[] appliedParameters;
    int appliedParameters_length;
    X3dNode body1;
    X3dNode body2;
    float bounce;
    float[] contactNormal;
    int contactNormal_length;
    float depth;
    float[] frictionCoefficients;
    int frictionCoefficients_length;
    float[] frictionDirection;
    int frictionDirection_length;
    X3dNode geometry1;
    X3dNode geometry2;
    float minBounceSpeed;
    float[] position;
    int position_length;
    float[] slipCoefficients;
    int slipCoefficients_length;
    float softnessConstantForceMix;
    float softnessErrorCorrection;
    float[] surfaceSpeed;
    int surfaceSpeed_length;
    Contact() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderContact != null)
            X3dSceneGraph.callbackRenderContact.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (body1 != null)
            body1.treeRender();
        if (body2 != null)
            body2.treeRender();
        if (geometry1 != null)
            geometry1.treeRender();
        if (geometry2 != null)
            geometry2.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataContact != null)
            X3dSceneGraph.callbackDoWithDataContact.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (body1 != null)
            body1.treeDoWithData();
        if (body2 != null)
            body2.treeDoWithData();
        if (geometry1 != null)
            geometry1.treeDoWithData();
        if (geometry2 != null)
            geometry2.treeDoWithData();
    }
}

class ContactRenderCallback extends RenderCallback {}
class ContactDoWithDataCallback extends DoWithDataCallback {};


class ContourPolyline2D extends X3dNode {
    X3dNode metadata;
    float[] lineSegments;
    int lineSegments_length;
    ContourPolyline2D() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderContourPolyline2D != null)
            X3dSceneGraph.callbackRenderContourPolyline2D.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataContourPolyline2D != null)
            X3dSceneGraph.callbackDoWithDataContourPolyline2D.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class ContourPolyline2DRenderCallback extends RenderCallback {}
class ContourPolyline2DDoWithDataCallback extends DoWithDataCallback {};


class Disk2D extends X3dNode {
    X3dNode metadata;
    float innerRadius;
    float outerRadius;
    boolean solid;
    Disk2D() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderDisk2D != null)
            X3dSceneGraph.callbackRenderDisk2D.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataDisk2D != null)
            X3dSceneGraph.callbackDoWithDataDisk2D.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class Disk2DRenderCallback extends RenderCallback {}
class Disk2DDoWithDataCallback extends DoWithDataCallback {};


class GeoElevationGrid extends X3dNode {
    X3dNode metadata;
    X3dNode geoOrigin;
    String[] geoSystem;
    int geoSystem_length;
    X3dNode color;
    X3dNode normal;
    X3dNode texCoord;
    float yScale;
    boolean ccw;
    boolean colorPerVertex;
    double creaseAngle;
    double[] geoGridOrigin;
    int geoGridOrigin_length;
    double[] height;
    int height_length;
    boolean normalPerVertex;
    boolean solid;
    int xDimension;
    double xSpacing;
    int zDimension;
    double zSpacing;
    GeoElevationGrid() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderGeoElevationGrid != null)
            X3dSceneGraph.callbackRenderGeoElevationGrid.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (geoOrigin != null)
            geoOrigin.treeRender();
        if (color != null)
            color.treeRender();
        if (normal != null)
            normal.treeRender();
        if (texCoord != null)
            texCoord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataGeoElevationGrid != null)
            X3dSceneGraph.callbackDoWithDataGeoElevationGrid.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (geoOrigin != null)
            geoOrigin.treeDoWithData();
        if (color != null)
            color.treeDoWithData();
        if (normal != null)
            normal.treeDoWithData();
        if (texCoord != null)
            texCoord.treeDoWithData();
    }
}

class GeoElevationGridRenderCallback extends RenderCallback {}
class GeoElevationGridDoWithDataCallback extends DoWithDataCallback {};


class IndexedTriangleSet extends X3dNode {
    X3dNode metadata;
    X3dNode color;
    X3dNode coord;
    X3dNode normal;
    X3dNode texCoord;
    boolean ccw;
    boolean normalPerVertex;
    boolean solid;
    int[] index;
    int index_length;
    boolean colorPerVertex;
    IndexedTriangleSet() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderIndexedTriangleSet != null)
            X3dSceneGraph.callbackRenderIndexedTriangleSet.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (color != null)
            color.treeRender();
        if (coord != null)
            coord.treeRender();
        if (normal != null)
            normal.treeRender();
        if (texCoord != null)
            texCoord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataIndexedTriangleSet != null)
            X3dSceneGraph.callbackDoWithDataIndexedTriangleSet.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (color != null)
            color.treeDoWithData();
        if (coord != null)
            coord.treeDoWithData();
        if (normal != null)
            normal.treeDoWithData();
        if (texCoord != null)
            texCoord.treeDoWithData();
    }
}

class IndexedTriangleSetRenderCallback extends RenderCallback {}
class IndexedTriangleSetDoWithDataCallback extends DoWithDataCallback {};


class MotorJoint extends X3dNode {
    X3dNode metadata;
    X3dNode body1;
    X3dNode body2;
    String[] forceOutput;
    int forceOutput_length;
    float axis1Angle;
    float axis1Torque;
    float axis2Angle;
    float axis2Torque;
    float axis3Angle;
    float axis3Torque;
    int enabledAxes;
    float[] motor1Axis;
    int motor1Axis_length;
    float[] motor2Axis;
    int motor2Axis_length;
    float[] motor3Axis;
    int motor3Axis_length;
    float stop1Bounce;
    float stop1ErrorCorrection;
    float stop2Bounce;
    float stop2ErrorCorrection;
    float stop3Bounce;
    float stop3ErrorCorrection;
    boolean autoCalc;
    MotorJoint() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderMotorJoint != null)
            X3dSceneGraph.callbackRenderMotorJoint.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (body1 != null)
            body1.treeRender();
        if (body2 != null)
            body2.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataMotorJoint != null)
            X3dSceneGraph.callbackDoWithDataMotorJoint.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (body1 != null)
            body1.treeDoWithData();
        if (body2 != null)
            body2.treeDoWithData();
    }
}

class MotorJointRenderCallback extends RenderCallback {}
class MotorJointDoWithDataCallback extends DoWithDataCallback {};


class Polypoint2D extends X3dNode {
    X3dNode metadata;
    float[] point;
    int point_length;
    Polypoint2D() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderPolypoint2D != null)
            X3dSceneGraph.callbackRenderPolypoint2D.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataPolypoint2D != null)
            X3dSceneGraph.callbackDoWithDataPolypoint2D.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class Polypoint2DRenderCallback extends RenderCallback {}
class Polypoint2DDoWithDataCallback extends DoWithDataCallback {};


class SuperEllipsoid extends X3dNode {
    X3dNode metadata;
    float n1;
    float n2;
    float border;
    boolean bottom;
    float bottomBorder;
    boolean ccw;
    float creaseAngle;
    float[] size;
    int size_length;
    boolean solid;
    X3dNode texCoord;
    boolean top;
    int uTessellation;
    int vTessellation;
    SuperEllipsoid() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderSuperEllipsoid != null)
            X3dSceneGraph.callbackRenderSuperEllipsoid.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (texCoord != null)
            texCoord.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataSuperEllipsoid != null)
            X3dSceneGraph.callbackDoWithDataSuperEllipsoid.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (texCoord != null)
            texCoord.treeDoWithData();
    }
}

class SuperEllipsoidRenderCallback extends RenderCallback {}
class SuperEllipsoidDoWithDataCallback extends DoWithDataCallback {};


class BooleanToggle extends X3dNode {
    X3dNode metadata;
    boolean toggle;
    BooleanToggle() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderBooleanToggle != null)
            X3dSceneGraph.callbackRenderBooleanToggle.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataBooleanToggle != null)
            X3dSceneGraph.callbackDoWithDataBooleanToggle.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class BooleanToggleRenderCallback extends RenderCallback {}
class BooleanToggleDoWithDataCallback extends DoWithDataCallback {};


class CoordinateDouble extends X3dNode {
    X3dNode metadata;
    double[] point;
    int point_length;
    CoordinateDouble() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCoordinateDouble != null)
            X3dSceneGraph.callbackRenderCoordinateDouble.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCoordinateDouble != null)
            X3dSceneGraph.callbackDoWithDataCoordinateDouble.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class CoordinateDoubleRenderCallback extends RenderCallback {}
class CoordinateDoubleDoWithDataCallback extends DoWithDataCallback {};


class MultiTexture extends X3dNode {
    X3dNode metadata;
    float alpha;
    float[] color;
    int color_length;
    String[] function;
    int function_length;
    String[] mode;
    int mode_length;
    String[] source;
    int source_length;
    X3dNode [] texture;
    int texture_length;
    MultiTexture() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderMultiTexture != null)
            X3dSceneGraph.callbackRenderMultiTexture.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < texture_length; i++)
            if (texture[i] != null)
                texture[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataMultiTexture != null)
            X3dSceneGraph.callbackDoWithDataMultiTexture.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < texture_length; i++)
            if (texture[i] != null)
                texture[i].treeDoWithData();
    }
}

class MultiTextureRenderCallback extends RenderCallback {}
class MultiTextureDoWithDataCallback extends DoWithDataCallback {};


class NurbsTrimmedSurface extends X3dNode {
    X3dNode metadata;
    int uDimension;
    int vDimension;
    float[] uKnot;
    int uKnot_length;
    float[] vKnot;
    int vKnot_length;
    int uOrder;
    int vOrder;
    X3dNode controlPoint;
    float[] weight;
    int weight_length;
    int uTessellation;
    int vTessellation;
    X3dNode texCoord;
    boolean ccw;
    boolean solid;
    X3dNode [] trimmingContour;
    int trimmingContour_length;
    NurbsTrimmedSurface() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNurbsTrimmedSurface != null)
            X3dSceneGraph.callbackRenderNurbsTrimmedSurface.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (controlPoint != null)
            controlPoint.treeRender();
        if (texCoord != null)
            texCoord.treeRender();
        for (int i = 0; i < trimmingContour_length; i++)
            if (trimmingContour[i] != null)
                trimmingContour[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNurbsTrimmedSurface != null)
            X3dSceneGraph.callbackDoWithDataNurbsTrimmedSurface.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (controlPoint != null)
            controlPoint.treeDoWithData();
        if (texCoord != null)
            texCoord.treeDoWithData();
        for (int i = 0; i < trimmingContour_length; i++)
            if (trimmingContour[i] != null)
                trimmingContour[i].treeDoWithData();
    }
}

class NurbsTrimmedSurfaceRenderCallback extends RenderCallback {}
class NurbsTrimmedSurfaceDoWithDataCallback extends DoWithDataCallback {};


class Shape extends X3dNode {
    X3dNode metadata;
    X3dNode appearance;
    X3dNode geometry;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    Shape() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderShape != null)
            X3dSceneGraph.callbackRenderShape.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (appearance != null)
            appearance.treeRender();
        if (geometry != null)
            geometry.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataShape != null)
            X3dSceneGraph.callbackDoWithDataShape.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (appearance != null)
            appearance.treeDoWithData();
        if (geometry != null)
            geometry.treeDoWithData();
    }
}

class ShapeRenderCallback extends RenderCallback {}
class ShapeDoWithDataCallback extends DoWithDataCallback {};


class Box extends X3dNode {
    X3dNode metadata;
    float[] size;
    int size_length;
    boolean solid;
    Box() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderBox != null)
            X3dSceneGraph.callbackRenderBox.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataBox != null)
            X3dSceneGraph.callbackDoWithDataBox.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class BoxRenderCallback extends RenderCallback {}
class BoxDoWithDataCallback extends DoWithDataCallback {};


class GeoLocation extends X3dNode {
    X3dNode metadata;
    X3dNode geoOrigin;
    String[] geoSystem;
    int geoSystem_length;
    X3dNode [] children;
    int children_length;
    double[] geoCoords;
    int geoCoords_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    GeoLocation() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderGeoLocation != null)
            X3dSceneGraph.callbackRenderGeoLocation.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (geoOrigin != null)
            geoOrigin.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataGeoLocation != null)
            X3dSceneGraph.callbackDoWithDataGeoLocation.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (geoOrigin != null)
            geoOrigin.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
    }
}

class GeoLocationRenderCallback extends RenderCallback {}
class GeoLocationDoWithDataCallback extends DoWithDataCallback {};


class Cylinder extends X3dNode {
    X3dNode metadata;
    boolean bottom;
    float height;
    float radius;
    boolean side;
    boolean solid;
    boolean top;
    Cylinder() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCylinder != null)
            X3dSceneGraph.callbackRenderCylinder.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCylinder != null)
            X3dSceneGraph.callbackDoWithDataCylinder.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class CylinderRenderCallback extends RenderCallback {}
class CylinderDoWithDataCallback extends DoWithDataCallback {};


class NormalInterpolator extends X3dNode {
    X3dNode metadata;
    float[] key;
    int key_length;
    float[] keyValue;
    int keyValue_length;
    NormalInterpolator() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNormalInterpolator != null)
            X3dSceneGraph.callbackRenderNormalInterpolator.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNormalInterpolator != null)
            X3dSceneGraph.callbackDoWithDataNormalInterpolator.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class NormalInterpolatorRenderCallback extends RenderCallback {}
class NormalInterpolatorDoWithDataCallback extends DoWithDataCallback {};


class ScalarInterpolator extends X3dNode {
    X3dNode metadata;
    float[] key;
    int key_length;
    float[] keyValue;
    int keyValue_length;
    ScalarInterpolator() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderScalarInterpolator != null)
            X3dSceneGraph.callbackRenderScalarInterpolator.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataScalarInterpolator != null)
            X3dSceneGraph.callbackDoWithDataScalarInterpolator.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class ScalarInterpolatorRenderCallback extends RenderCallback {}
class ScalarInterpolatorDoWithDataCallback extends DoWithDataCallback {};


class TouchSensor extends X3dNode {
    X3dNode metadata;
    String description;
    boolean enabled;
    TouchSensor() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderTouchSensor != null)
            X3dSceneGraph.callbackRenderTouchSensor.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataTouchSensor != null)
            X3dSceneGraph.callbackDoWithDataTouchSensor.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class TouchSensorRenderCallback extends RenderCallback {}
class TouchSensorDoWithDataCallback extends DoWithDataCallback {};


class CattExportRec extends X3dNode {
    X3dNode metadata;
    int id;
    float[] receiverLocation;
    int receiverLocation_length;
    String furtherParameters;
    CattExportRec() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCattExportRec != null)
            X3dSceneGraph.callbackRenderCattExportRec.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCattExportRec != null)
            X3dSceneGraph.callbackDoWithDataCattExportRec.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class CattExportRecRenderCallback extends RenderCallback {}
class CattExportRecDoWithDataCallback extends DoWithDataCallback {};


class FillProperties extends X3dNode {
    X3dNode metadata;
    boolean filled;
    float[] hatchColor;
    int hatchColor_length;
    boolean hatched;
    int hatchStyle;
    FillProperties() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderFillProperties != null)
            X3dSceneGraph.callbackRenderFillProperties.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataFillProperties != null)
            X3dSceneGraph.callbackDoWithDataFillProperties.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class FillPropertiesRenderCallback extends RenderCallback {}
class FillPropertiesDoWithDataCallback extends DoWithDataCallback {};


class HAnimSegment extends X3dNode {
    X3dNode metadata;
    X3dNode [] children;
    int children_length;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    float[] centerOfMass;
    int centerOfMass_length;
    X3dNode coord;
    X3dNode [] displacers;
    int displacers_length;
    float mass;
    float[] momentsOfInertia;
    int momentsOfInertia_length;
    String name;
    HAnimSegment() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderHAnimSegment != null)
            X3dSceneGraph.callbackRenderHAnimSegment.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeRender();
        if (coord != null)
            coord.treeRender();
        for (int i = 0; i < displacers_length; i++)
            if (displacers[i] != null)
                displacers[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataHAnimSegment != null)
            X3dSceneGraph.callbackDoWithDataHAnimSegment.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < children_length; i++)
            if (children[i] != null)
                children[i].treeDoWithData();
        if (coord != null)
            coord.treeDoWithData();
        for (int i = 0; i < displacers_length; i++)
            if (displacers[i] != null)
                displacers[i].treeDoWithData();
    }
}

class HAnimSegmentRenderCallback extends RenderCallback {}
class HAnimSegmentDoWithDataCallback extends DoWithDataCallback {};


class PointLight extends X3dNode {
    X3dNode metadata;
    float ambientIntensity;
    float[] attenuation;
    int attenuation_length;
    float[] color;
    int color_length;
    float intensity;
    float[] location;
    int location_length;
    boolean on;
    float radius;
    boolean kambiShadows;
    boolean kambiShadowsMain;
    PointLight() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderPointLight != null)
            X3dSceneGraph.callbackRenderPointLight.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataPointLight != null)
            X3dSceneGraph.callbackDoWithDataPointLight.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class PointLightRenderCallback extends RenderCallback {}
class PointLightDoWithDataCallback extends DoWithDataCallback {};


class SliderJoint extends X3dNode {
    X3dNode metadata;
    X3dNode body1;
    X3dNode body2;
    String[] forceOutput;
    int forceOutput_length;
    float[] axis;
    int axis_length;
    float maxSeparation;
    float minSeparation;
    float stopBounce;
    float stopErrorCorrection;
    SliderJoint() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderSliderJoint != null)
            X3dSceneGraph.callbackRenderSliderJoint.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (body1 != null)
            body1.treeRender();
        if (body2 != null)
            body2.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataSliderJoint != null)
            X3dSceneGraph.callbackDoWithDataSliderJoint.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (body1 != null)
            body1.treeDoWithData();
        if (body2 != null)
            body2.treeDoWithData();
    }
}

class SliderJointRenderCallback extends RenderCallback {}
class SliderJointDoWithDataCallback extends DoWithDataCallback {};


class Text extends X3dNode {
    X3dNode metadata;
    X3dNode fontStyle;
    float[] length;
    int length_length;
    float maxExtent;
    String[] string;
    int string_length;
    boolean solid;
    Text() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderText != null)
            X3dSceneGraph.callbackRenderText.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (fontStyle != null)
            fontStyle.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataText != null)
            X3dSceneGraph.callbackDoWithDataText.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (fontStyle != null)
            fontStyle.treeDoWithData();
    }
}

class TextRenderCallback extends RenderCallback {}
class TextDoWithDataCallback extends DoWithDataCallback {};


class TextureBackground extends X3dNode {
    X3dNode metadata;
    float[] groundAngle;
    int groundAngle_length;
    float[] groundColor;
    int groundColor_length;
    X3dNode backUrl;
    X3dNode rightUrl;
    X3dNode frontUrl;
    X3dNode leftUrl;
    X3dNode topUrl;
    X3dNode bottomUrl;
    float[] skyAngle;
    int skyAngle_length;
    float[] skyColor;
    int skyColor_length;
    TextureBackground() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderTextureBackground != null)
            X3dSceneGraph.callbackRenderTextureBackground.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (backUrl != null)
            backUrl.treeRender();
        if (rightUrl != null)
            rightUrl.treeRender();
        if (frontUrl != null)
            frontUrl.treeRender();
        if (leftUrl != null)
            leftUrl.treeRender();
        if (topUrl != null)
            topUrl.treeRender();
        if (bottomUrl != null)
            bottomUrl.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataTextureBackground != null)
            X3dSceneGraph.callbackDoWithDataTextureBackground.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (backUrl != null)
            backUrl.treeDoWithData();
        if (rightUrl != null)
            rightUrl.treeDoWithData();
        if (frontUrl != null)
            frontUrl.treeDoWithData();
        if (leftUrl != null)
            leftUrl.treeDoWithData();
        if (topUrl != null)
            topUrl.treeDoWithData();
        if (bottomUrl != null)
            bottomUrl.treeDoWithData();
    }
}

class TextureBackgroundRenderCallback extends RenderCallback {}
class TextureBackgroundDoWithDataCallback extends DoWithDataCallback {};


class TriangleSet2D extends X3dNode {
    X3dNode metadata;
    float[] vertices;
    int vertices_length;
    boolean solid;
    TriangleSet2D() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderTriangleSet2D != null)
            X3dSceneGraph.callbackRenderTriangleSet2D.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataTriangleSet2D != null)
            X3dSceneGraph.callbackDoWithDataTriangleSet2D.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class TriangleSet2DRenderCallback extends RenderCallback {}
class TriangleSet2DDoWithDataCallback extends DoWithDataCallback {};


class Appearance extends X3dNode {
    X3dNode metadata;
    X3dNode material;
    X3dNode texture;
    X3dNode textureTransform;
    X3dNode fillProperties;
    X3dNode lineProperties;
    Appearance() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderAppearance != null)
            X3dSceneGraph.callbackRenderAppearance.render(this);
        if (metadata != null)
            metadata.treeRender();
        if (material != null)
            material.treeRender();
        if (texture != null)
            texture.treeRender();
        if (textureTransform != null)
            textureTransform.treeRender();
        if (fillProperties != null)
            fillProperties.treeRender();
        if (lineProperties != null)
            lineProperties.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataAppearance != null)
            X3dSceneGraph.callbackDoWithDataAppearance.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        if (material != null)
            material.treeDoWithData();
        if (texture != null)
            texture.treeDoWithData();
        if (textureTransform != null)
            textureTransform.treeDoWithData();
        if (fillProperties != null)
            fillProperties.treeDoWithData();
        if (lineProperties != null)
            lineProperties.treeDoWithData();
    }
}

class AppearanceRenderCallback extends RenderCallback {}
class AppearanceDoWithDataCallback extends DoWithDataCallback {};


class CollisionSpace extends X3dNode {
    X3dNode metadata;
    boolean enabled;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    X3dNode [] collidables;
    int collidables_length;
    boolean useGeometry;
    CollisionSpace() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderCollisionSpace != null)
            X3dSceneGraph.callbackRenderCollisionSpace.render(this);
        if (metadata != null)
            metadata.treeRender();
        for (int i = 0; i < collidables_length; i++)
            if (collidables[i] != null)
                collidables[i].treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataCollisionSpace != null)
            X3dSceneGraph.callbackDoWithDataCollisionSpace.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
        for (int i = 0; i < collidables_length; i++)
            if (collidables[i] != null)
                collidables[i].treeDoWithData();
    }
}

class CollisionSpaceRenderCallback extends RenderCallback {}
class CollisionSpaceDoWithDataCallback extends DoWithDataCallback {};


class NurbsTextureCoordinate extends X3dNode {
    X3dNode metadata;
    int uDimension;
    int vDimension;
    float[] uKnot;
    int uKnot_length;
    float[] vKnot;
    int vKnot_length;
    int uOrder;
    int vOrder;
    float[] controlPoint;
    int controlPoint_length;
    float[] weight;
    int weight_length;
    NurbsTextureCoordinate() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNurbsTextureCoordinate != null)
            X3dSceneGraph.callbackRenderNurbsTextureCoordinate.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNurbsTextureCoordinate != null)
            X3dSceneGraph.callbackDoWithDataNurbsTextureCoordinate.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class NurbsTextureCoordinateRenderCallback extends RenderCallback {}
class NurbsTextureCoordinateDoWithDataCallback extends DoWithDataCallback {};


class ReceiverPdu extends X3dNode {
    X3dNode metadata;
    int radioID;
    float receivedPower;
    int receiverState;
    int transmitterApplicationID;
    int transmitterEntityID;
    int transmitterRadioID;
    int transmitterSiteID;
    int whichGeometry;
    float[] bboxCenter;
    int bboxCenter_length;
    float[] bboxSize;
    int bboxSize_length;
    String networkMode;
    double readInterval;
    double writeInterval;
    int siteID;
    int applicationID;
    int entityID;
    String address;
    int port;
    String multicastRelayHost;
    int multicastRelayPort;
    boolean rtpHeaderExpected;
    ReceiverPdu() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderReceiverPdu != null)
            X3dSceneGraph.callbackRenderReceiverPdu.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataReceiverPdu != null)
            X3dSceneGraph.callbackDoWithDataReceiverPdu.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class ReceiverPduRenderCallback extends RenderCallback {}
class ReceiverPduDoWithDataCallback extends DoWithDataCallback {};


class TextureCoordinate extends X3dNode {
    X3dNode metadata;
    float[] point;
    int point_length;
    TextureCoordinate() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderTextureCoordinate != null)
            X3dSceneGraph.callbackRenderTextureCoordinate.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataTextureCoordinate != null)
            X3dSceneGraph.callbackDoWithDataTextureCoordinate.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class TextureCoordinateRenderCallback extends RenderCallback {}
class TextureCoordinateDoWithDataCallback extends DoWithDataCallback {};


class Normal extends X3dNode {
    X3dNode metadata;
    float[] vector;
    int vector_length;
    Normal() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderNormal != null)
            X3dSceneGraph.callbackRenderNormal.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataNormal != null)
            X3dSceneGraph.callbackDoWithDataNormal.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class NormalRenderCallback extends RenderCallback {}
class NormalDoWithDataCallback extends DoWithDataCallback {};


class TextureTransform extends X3dNode {
    X3dNode metadata;
    float[] center;
    int center_length;
    float rotation;
    float[] scale;
    int scale_length;
    float[] translation;
    int translation_length;
    TextureTransform() {
    }
    void treeRender() {
        if (X3dSceneGraph.callbackRenderTextureTransform != null)
            X3dSceneGraph.callbackRenderTextureTransform.render(this);
        if (metadata != null)
            metadata.treeRender();
    }
    void treeDoWithData() {
        if (X3dSceneGraph.callbackDoWithDataTextureTransform != null)
            X3dSceneGraph.callbackDoWithDataTextureTransform.doWithData(this);
        if (metadata != null)
            metadata.treeDoWithData();
    }
}

class TextureTransformRenderCallback extends RenderCallback {}
class TextureTransformDoWithDataCallback extends DoWithDataCallback {};



class X3dSceneGraph {
    Group root;
    Transform Transform_1;
    Shape Shape_2;
    Appearance Appearance_3;
    Material Material_4;
    Text Text_5;
    X3dSceneGraph() {
        root = new Group();
        Transform_1 = new Transform();
        Shape_2 = new Shape();
        Appearance_3 = new Appearance();
        Material_4 = new Material();
        Material_4.metadata = null;
        Material_4.ambientIntensity = 0.200000f;
        {
        float m_diffuseColor[] = { 0.800000f, 0.800000f, 0.800000f };
        Material_4.diffuseColor = m_diffuseColor;
        Material_4.diffuseColor_length = m_diffuseColor.length;
        }
        {
        float m_emissiveColor[] = { 0f, 0f, 0f };
        Material_4.emissiveColor = m_emissiveColor;
        Material_4.emissiveColor_length = m_emissiveColor.length;
        }
        Material_4.shininess = 0.200000f;
        {
        float m_specularColor[] = { 0f, 0f, 0f };
        Material_4.specularColor = m_specularColor;
        Material_4.specularColor_length = m_specularColor.length;
        }
        Material_4.transparency = 0f;
        Material_4.m_parent = Appearance_3;

        Appearance_3.metadata = null;
        Appearance_3.material = Material_4;
        Appearance_3.texture = null;
        Appearance_3.textureTransform = null;
        Appearance_3.fillProperties = null;
        Appearance_3.lineProperties = null;
        Appearance_3.m_parent = Shape_2;

        Text_5 = new Text();
        Text_5.metadata = null;
        Text_5.fontStyle = null;
        {
        float m_length[] = {  };
        Text_5.length = m_length;
        Text_5.length_length = m_length.length;
        }
        Text_5.maxExtent = 0f;
        {
        String m_string[] = { "Hello World" };
        Text_5.string = m_string;
        Text_5.string_length = m_string.length;
        }
        Text_5.solid = false;
        Text_5.m_parent = Shape_2;

        Shape_2.metadata = null;
        Shape_2.appearance = Appearance_3;
        Shape_2.geometry = Text_5;
        {
        float m_bboxCenter[] = { 0f, 0f, 0f };
        Shape_2.bboxCenter = m_bboxCenter;
        Shape_2.bboxCenter_length = m_bboxCenter.length;
        }
        {
        float m_bboxSize[] = { -1f, -1f, -1f };
        Shape_2.bboxSize = m_bboxSize;
        Shape_2.bboxSize_length = m_bboxSize.length;
        }
        Shape_2.m_parent = Transform_1;

        Transform_1.metadata = null;
        {
        float m_rotation[] = { 0f, 0f, 1f, 0f };
        Transform_1.rotation = m_rotation;
        Transform_1.rotation_length = m_rotation.length;
        }
        {
        float m_translation[] = { 0f, 0f, 0f };
        Transform_1.translation = m_translation;
        Transform_1.translation_length = m_translation.length;
        }
        {
        float m_bboxCenter[] = { 0f, 0f, 0f };
        Transform_1.bboxCenter = m_bboxCenter;
        Transform_1.bboxCenter_length = m_bboxCenter.length;
        }
        {
        float m_bboxSize[] = { -1f, -1f, -1f };
        Transform_1.bboxSize = m_bboxSize;
        Transform_1.bboxSize_length = m_bboxSize.length;
        }
        {
        float m_center[] = { 0f, 0f, 0f };
        Transform_1.center = m_center;
        Transform_1.center_length = m_center.length;
        }
        {
        float m_scale[] = { 1f, 1f, 1f };
        Transform_1.scale = m_scale;
        Transform_1.scale_length = m_scale.length;
        }
        {
        float m_scaleOrientation[] = { 0f, 0f, 1f, 0f };
        Transform_1.scaleOrientation = m_scaleOrientation;
        Transform_1.scaleOrientation_length = m_scaleOrientation.length;
        }
        {
        X3dNode [] m_children = { Shape_2 };
        Transform_1.children = m_children;
        Transform_1.children_length = m_children.length;
        }
        Transform_1.m_parent = root;

        root.metadata = null;
        {
        X3dNode [] m_children = { Transform_1 };
        root.children = m_children;
        root.children_length = m_children.length;
        }
        {
        float m_bboxCenter[] = { 0f, 0f, 0f };
        root.bboxCenter = m_bboxCenter;
        root.bboxCenter_length = m_bboxCenter.length;
        }
        {
        float m_bboxSize[] = { -1f, -1f, -1f };
        root.bboxSize = m_bboxSize;
        root.bboxSize_length = m_bboxSize.length;
        }
        root.m_parent = null;

    }
    static ColorRGBARenderCallback callbackRenderColorRGBA;
    void setColorRGBARenderCallback(ColorRGBARenderCallback node) {
        callbackRenderColorRGBA = node;
    }

    static ColorRGBADoWithDataCallback callbackDoWithDataColorRGBA;
    void setColorRGBADoWithDataCallback(ColorRGBADoWithDataCallback node) {
         callbackDoWithDataColorRGBA = node;
    }

    static BooleanFilterRenderCallback callbackRenderBooleanFilter;
    void setBooleanFilterRenderCallback(BooleanFilterRenderCallback node) {
        callbackRenderBooleanFilter = node;
    }

    static BooleanFilterDoWithDataCallback callbackDoWithDataBooleanFilter;
    void setBooleanFilterDoWithDataCallback(BooleanFilterDoWithDataCallback node) {
         callbackDoWithDataBooleanFilter = node;
    }

    static HAnimDisplacerRenderCallback callbackRenderHAnimDisplacer;
    void setHAnimDisplacerRenderCallback(HAnimDisplacerRenderCallback node) {
        callbackRenderHAnimDisplacer = node;
    }

    static HAnimDisplacerDoWithDataCallback callbackDoWithDataHAnimDisplacer;
    void setHAnimDisplacerDoWithDataCallback(HAnimDisplacerDoWithDataCallback node) {
         callbackDoWithDataHAnimDisplacer = node;
    }

    static BillboardRenderCallback callbackRenderBillboard;
    void setBillboardRenderCallback(BillboardRenderCallback node) {
        callbackRenderBillboard = node;
    }

    static BillboardDoWithDataCallback callbackDoWithDataBillboard;
    void setBillboardDoWithDataCallback(BillboardDoWithDataCallback node) {
         callbackDoWithDataBillboard = node;
    }

    static Contour2DRenderCallback callbackRenderContour2D;
    void setContour2DRenderCallback(Contour2DRenderCallback node) {
        callbackRenderContour2D = node;
    }

    static Contour2DDoWithDataCallback callbackDoWithDataContour2D;
    void setContour2DDoWithDataCallback(Contour2DDoWithDataCallback node) {
         callbackDoWithDataContour2D = node;
    }

    static HAnimJointRenderCallback callbackRenderHAnimJoint;
    void setHAnimJointRenderCallback(HAnimJointRenderCallback node) {
        callbackRenderHAnimJoint = node;
    }

    static HAnimJointDoWithDataCallback callbackDoWithDataHAnimJoint;
    void setHAnimJointDoWithDataCallback(HAnimJointDoWithDataCallback node) {
         callbackDoWithDataHAnimJoint = node;
    }

    static SpotLightRenderCallback callbackRenderSpotLight;
    void setSpotLightRenderCallback(SpotLightRenderCallback node) {
        callbackRenderSpotLight = node;
    }

    static SpotLightDoWithDataCallback callbackDoWithDataSpotLight;
    void setSpotLightDoWithDataCallback(SpotLightDoWithDataCallback node) {
         callbackDoWithDataSpotLight = node;
    }

    static UniversalJointRenderCallback callbackRenderUniversalJoint;
    void setUniversalJointRenderCallback(UniversalJointRenderCallback node) {
        callbackRenderUniversalJoint = node;
    }

    static UniversalJointDoWithDataCallback callbackDoWithDataUniversalJoint;
    void setUniversalJointDoWithDataCallback(UniversalJointDoWithDataCallback node) {
         callbackDoWithDataUniversalJoint = node;
    }

    static GeoCoordinateRenderCallback callbackRenderGeoCoordinate;
    void setGeoCoordinateRenderCallback(GeoCoordinateRenderCallback node) {
        callbackRenderGeoCoordinate = node;
    }

    static GeoCoordinateDoWithDataCallback callbackDoWithDataGeoCoordinate;
    void setGeoCoordinateDoWithDataCallback(GeoCoordinateDoWithDataCallback node) {
         callbackDoWithDataGeoCoordinate = node;
    }

    static SphereRenderCallback callbackRenderSphere;
    void setSphereRenderCallback(SphereRenderCallback node) {
        callbackRenderSphere = node;
    }

    static SphereDoWithDataCallback callbackDoWithDataSphere;
    void setSphereDoWithDataCallback(SphereDoWithDataCallback node) {
         callbackDoWithDataSphere = node;
    }

    static SuperShapeRenderCallback callbackRenderSuperShape;
    void setSuperShapeRenderCallback(SuperShapeRenderCallback node) {
        callbackRenderSuperShape = node;
    }

    static SuperShapeDoWithDataCallback callbackDoWithDataSuperShape;
    void setSuperShapeDoWithDataCallback(SuperShapeDoWithDataCallback node) {
         callbackDoWithDataSuperShape = node;
    }

    static TransmitterPduRenderCallback callbackRenderTransmitterPdu;
    void setTransmitterPduRenderCallback(TransmitterPduRenderCallback node) {
        callbackRenderTransmitterPdu = node;
    }

    static TransmitterPduDoWithDataCallback callbackDoWithDataTransmitterPdu;
    void setTransmitterPduDoWithDataCallback(TransmitterPduDoWithDataCallback node) {
         callbackDoWithDataTransmitterPdu = node;
    }

    static TransformRenderCallback callbackRenderTransform;
    void setTransformRenderCallback(TransformRenderCallback node) {
        callbackRenderTransform = node;
    }

    static TransformDoWithDataCallback callbackDoWithDataTransform;
    void setTransformDoWithDataCallback(TransformDoWithDataCallback node) {
         callbackDoWithDataTransform = node;
    }

    static RigidBodyCollectionRenderCallback callbackRenderRigidBodyCollection;
    void setRigidBodyCollectionRenderCallback(RigidBodyCollectionRenderCallback node) {
        callbackRenderRigidBodyCollection = node;
    }

    static RigidBodyCollectionDoWithDataCallback callbackDoWithDataRigidBodyCollection;
    void setRigidBodyCollectionDoWithDataCallback(RigidBodyCollectionDoWithDataCallback node) {
         callbackDoWithDataRigidBodyCollection = node;
    }

    static SuperExtrusionRenderCallback callbackRenderSuperExtrusion;
    void setSuperExtrusionRenderCallback(SuperExtrusionRenderCallback node) {
        callbackRenderSuperExtrusion = node;
    }

    static SuperExtrusionDoWithDataCallback callbackDoWithDataSuperExtrusion;
    void setSuperExtrusionDoWithDataCallback(SuperExtrusionDoWithDataCallback node) {
         callbackDoWithDataSuperExtrusion = node;
    }

    static GeoMetadataRenderCallback callbackRenderGeoMetadata;
    void setGeoMetadataRenderCallback(GeoMetadataRenderCallback node) {
        callbackRenderGeoMetadata = node;
    }

    static GeoMetadataDoWithDataCallback callbackDoWithDataGeoMetadata;
    void setGeoMetadataDoWithDataCallback(GeoMetadataDoWithDataCallback node) {
         callbackDoWithDataGeoMetadata = node;
    }

    static ColorInterpolatorRenderCallback callbackRenderColorInterpolator;
    void setColorInterpolatorRenderCallback(ColorInterpolatorRenderCallback node) {
        callbackRenderColorInterpolator = node;
    }

    static ColorInterpolatorDoWithDataCallback callbackDoWithDataColorInterpolator;
    void setColorInterpolatorDoWithDataCallback(ColorInterpolatorDoWithDataCallback node) {
         callbackDoWithDataColorInterpolator = node;
    }

    static CylinderSensorRenderCallback callbackRenderCylinderSensor;
    void setCylinderSensorRenderCallback(CylinderSensorRenderCallback node) {
        callbackRenderCylinderSensor = node;
    }

    static CylinderSensorDoWithDataCallback callbackDoWithDataCylinderSensor;
    void setCylinderSensorDoWithDataCallback(CylinderSensorDoWithDataCallback node) {
         callbackDoWithDataCylinderSensor = node;
    }

    static LoadSensorRenderCallback callbackRenderLoadSensor;
    void setLoadSensorRenderCallback(LoadSensorRenderCallback node) {
        callbackRenderLoadSensor = node;
    }

    static LoadSensorDoWithDataCallback callbackDoWithDataLoadSensor;
    void setLoadSensorDoWithDataCallback(LoadSensorDoWithDataCallback node) {
         callbackDoWithDataLoadSensor = node;
    }

    static SuperRevolverRenderCallback callbackRenderSuperRevolver;
    void setSuperRevolverRenderCallback(SuperRevolverRenderCallback node) {
        callbackRenderSuperRevolver = node;
    }

    static SuperRevolverDoWithDataCallback callbackDoWithDataSuperRevolver;
    void setSuperRevolverDoWithDataCallback(SuperRevolverDoWithDataCallback node) {
         callbackDoWithDataSuperRevolver = node;
    }

    static TextureCoordinateGeneratorRenderCallback callbackRenderTextureCoordinateGenerator;
    void setTextureCoordinateGeneratorRenderCallback(TextureCoordinateGeneratorRenderCallback node) {
        callbackRenderTextureCoordinateGenerator = node;
    }

    static TextureCoordinateGeneratorDoWithDataCallback callbackDoWithDataTextureCoordinateGenerator;
    void setTextureCoordinateGeneratorDoWithDataCallback(TextureCoordinateGeneratorDoWithDataCallback node) {
         callbackDoWithDataTextureCoordinateGenerator = node;
    }

    static LinePropertiesRenderCallback callbackRenderLineProperties;
    void setLinePropertiesRenderCallback(LinePropertiesRenderCallback node) {
        callbackRenderLineProperties = node;
    }

    static LinePropertiesDoWithDataCallback callbackDoWithDataLineProperties;
    void setLinePropertiesDoWithDataCallback(LinePropertiesDoWithDataCallback node) {
         callbackDoWithDataLineProperties = node;
    }

    static ArcClose2DRenderCallback callbackRenderArcClose2D;
    void setArcClose2DRenderCallback(ArcClose2DRenderCallback node) {
        callbackRenderArcClose2D = node;
    }

    static ArcClose2DDoWithDataCallback callbackDoWithDataArcClose2D;
    void setArcClose2DDoWithDataCallback(ArcClose2DDoWithDataCallback node) {
         callbackDoWithDataArcClose2D = node;
    }

    static ElevationGridRenderCallback callbackRenderElevationGrid;
    void setElevationGridRenderCallback(ElevationGridRenderCallback node) {
        callbackRenderElevationGrid = node;
    }

    static ElevationGridDoWithDataCallback callbackDoWithDataElevationGrid;
    void setElevationGridDoWithDataCallback(ElevationGridDoWithDataCallback node) {
         callbackDoWithDataElevationGrid = node;
    }

    static IndexedTriangleFanSetRenderCallback callbackRenderIndexedTriangleFanSet;
    void setIndexedTriangleFanSetRenderCallback(IndexedTriangleFanSetRenderCallback node) {
        callbackRenderIndexedTriangleFanSet = node;
    }

    static IndexedTriangleFanSetDoWithDataCallback callbackDoWithDataIndexedTriangleFanSet;
    void setIndexedTriangleFanSetDoWithDataCallback(IndexedTriangleFanSetDoWithDataCallback node) {
         callbackDoWithDataIndexedTriangleFanSet = node;
    }

    static LineSetRenderCallback callbackRenderLineSet;
    void setLineSetRenderCallback(LineSetRenderCallback node) {
        callbackRenderLineSet = node;
    }

    static LineSetDoWithDataCallback callbackDoWithDataLineSet;
    void setLineSetDoWithDataCallback(LineSetDoWithDataCallback node) {
         callbackDoWithDataLineSet = node;
    }

    static NurbsCurve2DRenderCallback callbackRenderNurbsCurve2D;
    void setNurbsCurve2DRenderCallback(NurbsCurve2DRenderCallback node) {
        callbackRenderNurbsCurve2D = node;
    }

    static NurbsCurve2DDoWithDataCallback callbackDoWithDataNurbsCurve2D;
    void setNurbsCurve2DDoWithDataCallback(NurbsCurve2DDoWithDataCallback node) {
         callbackDoWithDataNurbsCurve2D = node;
    }

    static NurbsSetRenderCallback callbackRenderNurbsSet;
    void setNurbsSetRenderCallback(NurbsSetRenderCallback node) {
        callbackRenderNurbsSet = node;
    }

    static NurbsSetDoWithDataCallback callbackDoWithDataNurbsSet;
    void setNurbsSetDoWithDataCallback(NurbsSetDoWithDataCallback node) {
         callbackDoWithDataNurbsSet = node;
    }

    static TriangleStripSetRenderCallback callbackRenderTriangleStripSet;
    void setTriangleStripSetRenderCallback(TriangleStripSetRenderCallback node) {
        callbackRenderTriangleStripSet = node;
    }

    static TriangleStripSetDoWithDataCallback callbackDoWithDataTriangleStripSet;
    void setTriangleStripSetDoWithDataCallback(TriangleStripSetDoWithDataCallback node) {
         callbackDoWithDataTriangleStripSet = node;
    }

    static VrmlCutRenderCallback callbackRenderVrmlCut;
    void setVrmlCutRenderCallback(VrmlCutRenderCallback node) {
        callbackRenderVrmlCut = node;
    }

    static VrmlCutDoWithDataCallback callbackDoWithDataVrmlCut;
    void setVrmlCutDoWithDataCallback(VrmlCutDoWithDataCallback node) {
         callbackDoWithDataVrmlCut = node;
    }

    static CollidableShapeRenderCallback callbackRenderCollidableShape;
    void setCollidableShapeRenderCallback(CollidableShapeRenderCallback node) {
        callbackRenderCollidableShape = node;
    }

    static CollidableShapeDoWithDataCallback callbackDoWithDataCollidableShape;
    void setCollidableShapeDoWithDataCallback(CollidableShapeDoWithDataCallback node) {
         callbackDoWithDataCollidableShape = node;
    }

    static NurbsSurfaceRenderCallback callbackRenderNurbsSurface;
    void setNurbsSurfaceRenderCallback(NurbsSurfaceRenderCallback node) {
        callbackRenderNurbsSurface = node;
    }

    static NurbsSurfaceDoWithDataCallback callbackDoWithDataNurbsSurface;
    void setNurbsSurfaceDoWithDataCallback(NurbsSurfaceDoWithDataCallback node) {
         callbackDoWithDataNurbsSurface = node;
    }

    static NurbsSweptSurfaceRenderCallback callbackRenderNurbsSweptSurface;
    void setNurbsSweptSurfaceRenderCallback(NurbsSweptSurfaceRenderCallback node) {
        callbackRenderNurbsSweptSurface = node;
    }

    static NurbsSweptSurfaceDoWithDataCallback callbackDoWithDataNurbsSweptSurface;
    void setNurbsSweptSurfaceDoWithDataCallback(NurbsSweptSurfaceDoWithDataCallback node) {
         callbackDoWithDataNurbsSweptSurface = node;
    }

    static PixelTextureRenderCallback callbackRenderPixelTexture;
    void setPixelTextureRenderCallback(PixelTextureRenderCallback node) {
        callbackRenderPixelTexture = node;
    }

    static PixelTextureDoWithDataCallback callbackDoWithDataPixelTexture;
    void setPixelTextureDoWithDataCallback(PixelTextureDoWithDataCallback node) {
         callbackDoWithDataPixelTexture = node;
    }

    static SwitchRenderCallback callbackRenderSwitch;
    void setSwitchRenderCallback(SwitchRenderCallback node) {
        callbackRenderSwitch = node;
    }

    static SwitchDoWithDataCallback callbackDoWithDataSwitch;
    void setSwitchDoWithDataCallback(SwitchDoWithDataCallback node) {
         callbackDoWithDataSwitch = node;
    }

    static CollisionSensorRenderCallback callbackRenderCollisionSensor;
    void setCollisionSensorRenderCallback(CollisionSensorRenderCallback node) {
        callbackRenderCollisionSensor = node;
    }

    static CollisionSensorDoWithDataCallback callbackDoWithDataCollisionSensor;
    void setCollisionSensorDoWithDataCallback(CollisionSensorDoWithDataCallback node) {
         callbackDoWithDataCollisionSensor = node;
    }

    static GeoTouchSensorRenderCallback callbackRenderGeoTouchSensor;
    void setGeoTouchSensorRenderCallback(GeoTouchSensorRenderCallback node) {
        callbackRenderGeoTouchSensor = node;
    }

    static GeoTouchSensorDoWithDataCallback callbackDoWithDataGeoTouchSensor;
    void setGeoTouchSensorDoWithDataCallback(GeoTouchSensorDoWithDataCallback node) {
         callbackDoWithDataGeoTouchSensor = node;
    }

    static IntegerSequencerRenderCallback callbackRenderIntegerSequencer;
    void setIntegerSequencerRenderCallback(IntegerSequencerRenderCallback node) {
        callbackRenderIntegerSequencer = node;
    }

    static IntegerSequencerDoWithDataCallback callbackDoWithDataIntegerSequencer;
    void setIntegerSequencerDoWithDataCallback(IntegerSequencerDoWithDataCallback node) {
         callbackDoWithDataIntegerSequencer = node;
    }

    static KeySensorRenderCallback callbackRenderKeySensor;
    void setKeySensorRenderCallback(KeySensorRenderCallback node) {
        callbackRenderKeySensor = node;
    }

    static KeySensorDoWithDataCallback callbackDoWithDataKeySensor;
    void setKeySensorDoWithDataCallback(KeySensorDoWithDataCallback node) {
         callbackDoWithDataKeySensor = node;
    }

    static PlaneSensorRenderCallback callbackRenderPlaneSensor;
    void setPlaneSensorRenderCallback(PlaneSensorRenderCallback node) {
        callbackRenderPlaneSensor = node;
    }

    static PlaneSensorDoWithDataCallback callbackDoWithDataPlaneSensor;
    void setPlaneSensorDoWithDataCallback(PlaneSensorDoWithDataCallback node) {
         callbackDoWithDataPlaneSensor = node;
    }

    static StringSensorRenderCallback callbackRenderStringSensor;
    void setStringSensorRenderCallback(StringSensorRenderCallback node) {
        callbackRenderStringSensor = node;
    }

    static StringSensorDoWithDataCallback callbackDoWithDataStringSensor;
    void setStringSensorDoWithDataCallback(StringSensorDoWithDataCallback node) {
         callbackDoWithDataStringSensor = node;
    }

    static CoordinateInterpolator2DRenderCallback callbackRenderCoordinateInterpolator2D;
    void setCoordinateInterpolator2DRenderCallback(CoordinateInterpolator2DRenderCallback node) {
        callbackRenderCoordinateInterpolator2D = node;
    }

    static CoordinateInterpolator2DDoWithDataCallback callbackDoWithDataCoordinateInterpolator2D;
    void setCoordinateInterpolator2DDoWithDataCallback(CoordinateInterpolator2DDoWithDataCallback node) {
         callbackDoWithDataCoordinateInterpolator2D = node;
    }

    static DoubleAxisHingeJointRenderCallback callbackRenderDoubleAxisHingeJoint;
    void setDoubleAxisHingeJointRenderCallback(DoubleAxisHingeJointRenderCallback node) {
        callbackRenderDoubleAxisHingeJoint = node;
    }

    static DoubleAxisHingeJointDoWithDataCallback callbackDoWithDataDoubleAxisHingeJoint;
    void setDoubleAxisHingeJointDoWithDataCallback(DoubleAxisHingeJointDoWithDataCallback node) {
         callbackDoWithDataDoubleAxisHingeJoint = node;
    }

    static GeoViewpointRenderCallback callbackRenderGeoViewpoint;
    void setGeoViewpointRenderCallback(GeoViewpointRenderCallback node) {
        callbackRenderGeoViewpoint = node;
    }

    static GeoViewpointDoWithDataCallback callbackDoWithDataGeoViewpoint;
    void setGeoViewpointDoWithDataCallback(GeoViewpointDoWithDataCallback node) {
         callbackDoWithDataGeoViewpoint = node;
    }

    static OdeSliderJointRenderCallback callbackRenderOdeSliderJoint;
    void setOdeSliderJointRenderCallback(OdeSliderJointRenderCallback node) {
        callbackRenderOdeSliderJoint = node;
    }

    static OdeSliderJointDoWithDataCallback callbackDoWithDataOdeSliderJoint;
    void setOdeSliderJointDoWithDataCallback(OdeSliderJointDoWithDataCallback node) {
         callbackDoWithDataOdeSliderJoint = node;
    }

    static Polyline2DRenderCallback callbackRenderPolyline2D;
    void setPolyline2DRenderCallback(Polyline2DRenderCallback node) {
        callbackRenderPolyline2D = node;
    }

    static Polyline2DDoWithDataCallback callbackDoWithDataPolyline2D;
    void setPolyline2DDoWithDataCallback(Polyline2DDoWithDataCallback node) {
         callbackDoWithDataPolyline2D = node;
    }

    static PositionInterpolator2DRenderCallback callbackRenderPositionInterpolator2D;
    void setPositionInterpolator2DRenderCallback(PositionInterpolator2DRenderCallback node) {
        callbackRenderPositionInterpolator2D = node;
    }

    static PositionInterpolator2DDoWithDataCallback callbackDoWithDataPositionInterpolator2D;
    void setPositionInterpolator2DDoWithDataCallback(PositionInterpolator2DDoWithDataCallback node) {
         callbackDoWithDataPositionInterpolator2D = node;
    }

    static ViewpointRenderCallback callbackRenderViewpoint;
    void setViewpointRenderCallback(ViewpointRenderCallback node) {
        callbackRenderViewpoint = node;
    }

    static ViewpointDoWithDataCallback callbackDoWithDataViewpoint;
    void setViewpointDoWithDataCallback(ViewpointDoWithDataCallback node) {
         callbackDoWithDataViewpoint = node;
    }

    static HAnimSiteRenderCallback callbackRenderHAnimSite;
    void setHAnimSiteRenderCallback(HAnimSiteRenderCallback node) {
        callbackRenderHAnimSite = node;
    }

    static HAnimSiteDoWithDataCallback callbackDoWithDataHAnimSite;
    void setHAnimSiteDoWithDataCallback(HAnimSiteDoWithDataCallback node) {
         callbackDoWithDataHAnimSite = node;
    }

    static ImageTextureRenderCallback callbackRenderImageTexture;
    void setImageTextureRenderCallback(ImageTextureRenderCallback node) {
        callbackRenderImageTexture = node;
    }

    static ImageTextureDoWithDataCallback callbackDoWithDataImageTexture;
    void setImageTextureDoWithDataCallback(ImageTextureDoWithDataCallback node) {
         callbackDoWithDataImageTexture = node;
    }

    static MovieTextureRenderCallback callbackRenderMovieTexture;
    void setMovieTextureRenderCallback(MovieTextureRenderCallback node) {
        callbackRenderMovieTexture = node;
    }

    static MovieTextureDoWithDataCallback callbackDoWithDataMovieTexture;
    void setMovieTextureDoWithDataCallback(MovieTextureDoWithDataCallback node) {
         callbackDoWithDataMovieTexture = node;
    }

    static ExtrusionRenderCallback callbackRenderExtrusion;
    void setExtrusionRenderCallback(ExtrusionRenderCallback node) {
        callbackRenderExtrusion = node;
    }

    static ExtrusionDoWithDataCallback callbackDoWithDataExtrusion;
    void setExtrusionDoWithDataCallback(ExtrusionDoWithDataCallback node) {
         callbackDoWithDataExtrusion = node;
    }

    static NavigationInfoRenderCallback callbackRenderNavigationInfo;
    void setNavigationInfoRenderCallback(NavigationInfoRenderCallback node) {
        callbackRenderNavigationInfo = node;
    }

    static NavigationInfoDoWithDataCallback callbackDoWithDataNavigationInfo;
    void setNavigationInfoDoWithDataCallback(NavigationInfoDoWithDataCallback node) {
         callbackDoWithDataNavigationInfo = node;
    }

    static WorldInfoRenderCallback callbackRenderWorldInfo;
    void setWorldInfoRenderCallback(WorldInfoRenderCallback node) {
        callbackRenderWorldInfo = node;
    }

    static WorldInfoDoWithDataCallback callbackDoWithDataWorldInfo;
    void setWorldInfoDoWithDataCallback(WorldInfoDoWithDataCallback node) {
         callbackDoWithDataWorldInfo = node;
    }

    static AudioClipRenderCallback callbackRenderAudioClip;
    void setAudioClipRenderCallback(AudioClipRenderCallback node) {
        callbackRenderAudioClip = node;
    }

    static AudioClipDoWithDataCallback callbackDoWithDataAudioClip;
    void setAudioClipDoWithDataCallback(AudioClipDoWithDataCallback node) {
         callbackDoWithDataAudioClip = node;
    }

    static CoordinateInterpolatorRenderCallback callbackRenderCoordinateInterpolator;
    void setCoordinateInterpolatorRenderCallback(CoordinateInterpolatorRenderCallback node) {
        callbackRenderCoordinateInterpolator = node;
    }

    static CoordinateInterpolatorDoWithDataCallback callbackDoWithDataCoordinateInterpolator;
    void setCoordinateInterpolatorDoWithDataCallback(CoordinateInterpolatorDoWithDataCallback node) {
         callbackDoWithDataCoordinateInterpolator = node;
    }

    static IntegerTriggerRenderCallback callbackRenderIntegerTrigger;
    void setIntegerTriggerRenderCallback(IntegerTriggerRenderCallback node) {
        callbackRenderIntegerTrigger = node;
    }

    static IntegerTriggerDoWithDataCallback callbackDoWithDataIntegerTrigger;
    void setIntegerTriggerDoWithDataCallback(IntegerTriggerDoWithDataCallback node) {
         callbackDoWithDataIntegerTrigger = node;
    }

    static DirectionalLightRenderCallback callbackRenderDirectionalLight;
    void setDirectionalLightRenderCallback(DirectionalLightRenderCallback node) {
        callbackRenderDirectionalLight = node;
    }

    static DirectionalLightDoWithDataCallback callbackDoWithDataDirectionalLight;
    void setDirectionalLightDoWithDataCallback(DirectionalLightDoWithDataCallback node) {
         callbackDoWithDataDirectionalLight = node;
    }

    static GeoLODRenderCallback callbackRenderGeoLOD;
    void setGeoLODRenderCallback(GeoLODRenderCallback node) {
        callbackRenderGeoLOD = node;
    }

    static GeoLODDoWithDataCallback callbackDoWithDataGeoLOD;
    void setGeoLODDoWithDataCallback(GeoLODDoWithDataCallback node) {
         callbackDoWithDataGeoLOD = node;
    }

    static LdrawDatExportRenderCallback callbackRenderLdrawDatExport;
    void setLdrawDatExportRenderCallback(LdrawDatExportRenderCallback node) {
        callbackRenderLdrawDatExport = node;
    }

    static LdrawDatExportDoWithDataCallback callbackDoWithDataLdrawDatExport;
    void setLdrawDatExportDoWithDataCallback(LdrawDatExportDoWithDataCallback node) {
         callbackDoWithDataLdrawDatExport = node;
    }

    static LODRenderCallback callbackRenderLOD;
    void setLODRenderCallback(LODRenderCallback node) {
        callbackRenderLOD = node;
    }

    static LODDoWithDataCallback callbackDoWithDataLOD;
    void setLODDoWithDataCallback(LODDoWithDataCallback node) {
         callbackDoWithDataLOD = node;
    }

    static MetadataSetRenderCallback callbackRenderMetadataSet;
    void setMetadataSetRenderCallback(MetadataSetRenderCallback node) {
        callbackRenderMetadataSet = node;
    }

    static MetadataSetDoWithDataCallback callbackDoWithDataMetadataSet;
    void setMetadataSetDoWithDataCallback(MetadataSetDoWithDataCallback node) {
         callbackDoWithDataMetadataSet = node;
    }

    static OdeSingleAxisHingeJointRenderCallback callbackRenderOdeSingleAxisHingeJoint;
    void setOdeSingleAxisHingeJointRenderCallback(OdeSingleAxisHingeJointRenderCallback node) {
        callbackRenderOdeSingleAxisHingeJoint = node;
    }

    static OdeSingleAxisHingeJointDoWithDataCallback callbackDoWithDataOdeSingleAxisHingeJoint;
    void setOdeSingleAxisHingeJointDoWithDataCallback(OdeSingleAxisHingeJointDoWithDataCallback node) {
         callbackDoWithDataOdeSingleAxisHingeJoint = node;
    }

    static PointSetRenderCallback callbackRenderPointSet;
    void setPointSetRenderCallback(PointSetRenderCallback node) {
        callbackRenderPointSet = node;
    }

    static PointSetDoWithDataCallback callbackDoWithDataPointSet;
    void setPointSetDoWithDataCallback(PointSetDoWithDataCallback node) {
         callbackDoWithDataPointSet = node;
    }

    static SingleAxisHingeJointRenderCallback callbackRenderSingleAxisHingeJoint;
    void setSingleAxisHingeJointRenderCallback(SingleAxisHingeJointRenderCallback node) {
        callbackRenderSingleAxisHingeJoint = node;
    }

    static SingleAxisHingeJointDoWithDataCallback callbackDoWithDataSingleAxisHingeJoint;
    void setSingleAxisHingeJointDoWithDataCallback(SingleAxisHingeJointDoWithDataCallback node) {
         callbackDoWithDataSingleAxisHingeJoint = node;
    }

    static MetadataDoubleRenderCallback callbackRenderMetadataDouble;
    void setMetadataDoubleRenderCallback(MetadataDoubleRenderCallback node) {
        callbackRenderMetadataDouble = node;
    }

    static MetadataDoubleDoWithDataCallback callbackDoWithDataMetadataDouble;
    void setMetadataDoubleDoWithDataCallback(MetadataDoubleDoWithDataCallback node) {
         callbackDoWithDataMetadataDouble = node;
    }

    static TrimmedSurfaceRenderCallback callbackRenderTrimmedSurface;
    void setTrimmedSurfaceRenderCallback(TrimmedSurfaceRenderCallback node) {
        callbackRenderTrimmedSurface = node;
    }

    static TrimmedSurfaceDoWithDataCallback callbackDoWithDataTrimmedSurface;
    void setTrimmedSurfaceDoWithDataCallback(TrimmedSurfaceDoWithDataCallback node) {
         callbackDoWithDataTrimmedSurface = node;
    }

    static CollisionRenderCallback callbackRenderCollision;
    void setCollisionRenderCallback(CollisionRenderCallback node) {
        callbackRenderCollision = node;
    }

    static CollisionDoWithDataCallback callbackDoWithDataCollision;
    void setCollisionDoWithDataCallback(CollisionDoWithDataCallback node) {
         callbackDoWithDataCollision = node;
    }

    static GeoOriginRenderCallback callbackRenderGeoOrigin;
    void setGeoOriginRenderCallback(GeoOriginRenderCallback node) {
        callbackRenderGeoOrigin = node;
    }

    static GeoOriginDoWithDataCallback callbackDoWithDataGeoOrigin;
    void setGeoOriginDoWithDataCallback(GeoOriginDoWithDataCallback node) {
         callbackDoWithDataGeoOrigin = node;
    }

    static GroupRenderCallback callbackRenderGroup;
    void setGroupRenderCallback(GroupRenderCallback node) {
        callbackRenderGroup = node;
    }

    static GroupDoWithDataCallback callbackDoWithDataGroup;
    void setGroupDoWithDataCallback(GroupDoWithDataCallback node) {
         callbackDoWithDataGroup = node;
    }

    static NurbsGroupRenderCallback callbackRenderNurbsGroup;
    void setNurbsGroupRenderCallback(NurbsGroupRenderCallback node) {
        callbackRenderNurbsGroup = node;
    }

    static NurbsGroupDoWithDataCallback callbackDoWithDataNurbsGroup;
    void setNurbsGroupDoWithDataCallback(NurbsGroupDoWithDataCallback node) {
         callbackDoWithDataNurbsGroup = node;
    }

    static CoordinateDeformerRenderCallback callbackRenderCoordinateDeformer;
    void setCoordinateDeformerRenderCallback(CoordinateDeformerRenderCallback node) {
        callbackRenderCoordinateDeformer = node;
    }

    static CoordinateDeformerDoWithDataCallback callbackDoWithDataCoordinateDeformer;
    void setCoordinateDeformerDoWithDataCallback(CoordinateDeformerDoWithDataCallback node) {
         callbackDoWithDataCoordinateDeformer = node;
    }

    static GeoPositionInterpolatorRenderCallback callbackRenderGeoPositionInterpolator;
    void setGeoPositionInterpolatorRenderCallback(GeoPositionInterpolatorRenderCallback node) {
        callbackRenderGeoPositionInterpolator = node;
    }

    static GeoPositionInterpolatorDoWithDataCallback callbackDoWithDataGeoPositionInterpolator;
    void setGeoPositionInterpolatorDoWithDataCallback(GeoPositionInterpolatorDoWithDataCallback node) {
         callbackDoWithDataGeoPositionInterpolator = node;
    }

    static PositionInterpolatorRenderCallback callbackRenderPositionInterpolator;
    void setPositionInterpolatorRenderCallback(PositionInterpolatorRenderCallback node) {
        callbackRenderPositionInterpolator = node;
    }

    static PositionInterpolatorDoWithDataCallback callbackDoWithDataPositionInterpolator;
    void setPositionInterpolatorDoWithDataCallback(PositionInterpolatorDoWithDataCallback node) {
         callbackDoWithDataPositionInterpolator = node;
    }

    static ProximitySensorRenderCallback callbackRenderProximitySensor;
    void setProximitySensorRenderCallback(ProximitySensorRenderCallback node) {
        callbackRenderProximitySensor = node;
    }

    static ProximitySensorDoWithDataCallback callbackDoWithDataProximitySensor;
    void setProximitySensorDoWithDataCallback(ProximitySensorDoWithDataCallback node) {
         callbackDoWithDataProximitySensor = node;
    }

    static VisibilitySensorRenderCallback callbackRenderVisibilitySensor;
    void setVisibilitySensorRenderCallback(VisibilitySensorRenderCallback node) {
        callbackRenderVisibilitySensor = node;
    }

    static VisibilitySensorDoWithDataCallback callbackDoWithDataVisibilitySensor;
    void setVisibilitySensorDoWithDataCallback(VisibilitySensorDoWithDataCallback node) {
         callbackDoWithDataVisibilitySensor = node;
    }

    static CattExportSrcRenderCallback callbackRenderCattExportSrc;
    void setCattExportSrcRenderCallback(CattExportSrcRenderCallback node) {
        callbackRenderCattExportSrc = node;
    }

    static CattExportSrcDoWithDataCallback callbackDoWithDataCattExportSrc;
    void setCattExportSrcDoWithDataCallback(CattExportSrcDoWithDataCallback node) {
         callbackDoWithDataCattExportSrc = node;
    }

    static Circle2DRenderCallback callbackRenderCircle2D;
    void setCircle2DRenderCallback(Circle2DRenderCallback node) {
        callbackRenderCircle2D = node;
    }

    static Circle2DDoWithDataCallback callbackDoWithDataCircle2D;
    void setCircle2DDoWithDataCallback(Circle2DDoWithDataCallback node) {
         callbackDoWithDataCircle2D = node;
    }

    static HAnimHumanoidRenderCallback callbackRenderHAnimHumanoid;
    void setHAnimHumanoidRenderCallback(HAnimHumanoidRenderCallback node) {
        callbackRenderHAnimHumanoid = node;
    }

    static HAnimHumanoidDoWithDataCallback callbackDoWithDataHAnimHumanoid;
    void setHAnimHumanoidDoWithDataCallback(HAnimHumanoidDoWithDataCallback node) {
         callbackDoWithDataHAnimHumanoid = node;
    }

    static IndexedFaceSetRenderCallback callbackRenderIndexedFaceSet;
    void setIndexedFaceSetRenderCallback(IndexedFaceSetRenderCallback node) {
        callbackRenderIndexedFaceSet = node;
    }

    static IndexedFaceSetDoWithDataCallback callbackDoWithDataIndexedFaceSet;
    void setIndexedFaceSetDoWithDataCallback(IndexedFaceSetDoWithDataCallback node) {
         callbackDoWithDataIndexedFaceSet = node;
    }

    static Rectangle2DRenderCallback callbackRenderRectangle2D;
    void setRectangle2DRenderCallback(Rectangle2DRenderCallback node) {
        callbackRenderRectangle2D = node;
    }

    static Rectangle2DDoWithDataCallback callbackDoWithDataRectangle2D;
    void setRectangle2DDoWithDataCallback(Rectangle2DDoWithDataCallback node) {
         callbackDoWithDataRectangle2D = node;
    }

    static SoundRenderCallback callbackRenderSound;
    void setSoundRenderCallback(SoundRenderCallback node) {
        callbackRenderSound = node;
    }

    static SoundDoWithDataCallback callbackDoWithDataSound;
    void setSoundDoWithDataCallback(SoundDoWithDataCallback node) {
         callbackDoWithDataSound = node;
    }

    static TriangleSetRenderCallback callbackRenderTriangleSet;
    void setTriangleSetRenderCallback(TriangleSetRenderCallback node) {
        callbackRenderTriangleSet = node;
    }

    static TriangleSetDoWithDataCallback callbackDoWithDataTriangleSet;
    void setTriangleSetDoWithDataCallback(TriangleSetDoWithDataCallback node) {
         callbackDoWithDataTriangleSet = node;
    }

    static ConeRenderCallback callbackRenderCone;
    void setConeRenderCallback(ConeRenderCallback node) {
        callbackRenderCone = node;
    }

    static ConeDoWithDataCallback callbackDoWithDataCone;
    void setConeDoWithDataCallback(ConeDoWithDataCallback node) {
         callbackDoWithDataCone = node;
    }

    static CoordinateRenderCallback callbackRenderCoordinate;
    void setCoordinateRenderCallback(CoordinateRenderCallback node) {
        callbackRenderCoordinate = node;
    }

    static CoordinateDoWithDataCallback callbackDoWithDataCoordinate;
    void setCoordinateDoWithDataCallback(CoordinateDoWithDataCallback node) {
         callbackDoWithDataCoordinate = node;
    }

    static FontStyleRenderCallback callbackRenderFontStyle;
    void setFontStyleRenderCallback(FontStyleRenderCallback node) {
        callbackRenderFontStyle = node;
    }

    static FontStyleDoWithDataCallback callbackDoWithDataFontStyle;
    void setFontStyleDoWithDataCallback(FontStyleDoWithDataCallback node) {
         callbackDoWithDataFontStyle = node;
    }

    static InlineRenderCallback callbackRenderInline;
    void setInlineRenderCallback(InlineRenderCallback node) {
        callbackRenderInline = node;
    }

    static InlineDoWithDataCallback callbackDoWithDataInline;
    void setInlineDoWithDataCallback(InlineDoWithDataCallback node) {
         callbackDoWithDataInline = node;
    }

    static MultiTextureCoordinateRenderCallback callbackRenderMultiTextureCoordinate;
    void setMultiTextureCoordinateRenderCallback(MultiTextureCoordinateRenderCallback node) {
        callbackRenderMultiTextureCoordinate = node;
    }

    static MultiTextureCoordinateDoWithDataCallback callbackDoWithDataMultiTextureCoordinate;
    void setMultiTextureCoordinateDoWithDataCallback(MultiTextureCoordinateDoWithDataCallback node) {
         callbackDoWithDataMultiTextureCoordinate = node;
    }

    static NurbsCurveRenderCallback callbackRenderNurbsCurve;
    void setNurbsCurveRenderCallback(NurbsCurveRenderCallback node) {
        callbackRenderNurbsCurve = node;
    }

    static NurbsCurveDoWithDataCallback callbackDoWithDataNurbsCurve;
    void setNurbsCurveDoWithDataCallback(NurbsCurveDoWithDataCallback node) {
         callbackDoWithDataNurbsCurve = node;
    }

    static NurbsSwungSurfaceRenderCallback callbackRenderNurbsSwungSurface;
    void setNurbsSwungSurfaceRenderCallback(NurbsSwungSurfaceRenderCallback node) {
        callbackRenderNurbsSwungSurface = node;
    }

    static NurbsSwungSurfaceDoWithDataCallback callbackDoWithDataNurbsSwungSurface;
    void setNurbsSwungSurfaceDoWithDataCallback(NurbsSwungSurfaceDoWithDataCallback node) {
         callbackDoWithDataNurbsSwungSurface = node;
    }

    static NurbsTextureSurfaceRenderCallback callbackRenderNurbsTextureSurface;
    void setNurbsTextureSurfaceRenderCallback(NurbsTextureSurfaceRenderCallback node) {
        callbackRenderNurbsTextureSurface = node;
    }

    static NurbsTextureSurfaceDoWithDataCallback callbackDoWithDataNurbsTextureSurface;
    void setNurbsTextureSurfaceDoWithDataCallback(NurbsTextureSurfaceDoWithDataCallback node) {
         callbackDoWithDataNurbsTextureSurface = node;
    }

    static SignalPduRenderCallback callbackRenderSignalPdu;
    void setSignalPduRenderCallback(SignalPduRenderCallback node) {
        callbackRenderSignalPdu = node;
    }

    static SignalPduDoWithDataCallback callbackDoWithDataSignalPdu;
    void setSignalPduDoWithDataCallback(SignalPduDoWithDataCallback node) {
         callbackDoWithDataSignalPdu = node;
    }

    static RigidBodyRenderCallback callbackRenderRigidBody;
    void setRigidBodyRenderCallback(RigidBodyRenderCallback node) {
        callbackRenderRigidBody = node;
    }

    static RigidBodyDoWithDataCallback callbackDoWithDataRigidBody;
    void setRigidBodyDoWithDataCallback(RigidBodyDoWithDataCallback node) {
         callbackDoWithDataRigidBody = node;
    }

    static MaterialRenderCallback callbackRenderMaterial;
    void setMaterialRenderCallback(MaterialRenderCallback node) {
        callbackRenderMaterial = node;
    }

    static MaterialDoWithDataCallback callbackDoWithDataMaterial;
    void setMaterialDoWithDataCallback(MaterialDoWithDataCallback node) {
         callbackDoWithDataMaterial = node;
    }

    static EspduTransformRenderCallback callbackRenderEspduTransform;
    void setEspduTransformRenderCallback(EspduTransformRenderCallback node) {
        callbackRenderEspduTransform = node;
    }

    static EspduTransformDoWithDataCallback callbackDoWithDataEspduTransform;
    void setEspduTransformDoWithDataCallback(EspduTransformDoWithDataCallback node) {
         callbackDoWithDataEspduTransform = node;
    }

    static MultiTextureTransformRenderCallback callbackRenderMultiTextureTransform;
    void setMultiTextureTransformRenderCallback(MultiTextureTransformRenderCallback node) {
        callbackRenderMultiTextureTransform = node;
    }

    static MultiTextureTransformDoWithDataCallback callbackDoWithDataMultiTextureTransform;
    void setMultiTextureTransformDoWithDataCallback(MultiTextureTransformDoWithDataCallback node) {
         callbackDoWithDataMultiTextureTransform = node;
    }

    static MetadataIntegerRenderCallback callbackRenderMetadataInteger;
    void setMetadataIntegerRenderCallback(MetadataIntegerRenderCallback node) {
        callbackRenderMetadataInteger = node;
    }

    static MetadataIntegerDoWithDataCallback callbackDoWithDataMetadataInteger;
    void setMetadataIntegerDoWithDataCallback(MetadataIntegerDoWithDataCallback node) {
         callbackDoWithDataMetadataInteger = node;
    }

    static NurbsOrientationInterpolatorRenderCallback callbackRenderNurbsOrientationInterpolator;
    void setNurbsOrientationInterpolatorRenderCallback(NurbsOrientationInterpolatorRenderCallback node) {
        callbackRenderNurbsOrientationInterpolator = node;
    }

    static NurbsOrientationInterpolatorDoWithDataCallback callbackDoWithDataNurbsOrientationInterpolator;
    void setNurbsOrientationInterpolatorDoWithDataCallback(NurbsOrientationInterpolatorDoWithDataCallback node) {
         callbackDoWithDataNurbsOrientationInterpolator = node;
    }

    static NurbsPositionInterpolatorRenderCallback callbackRenderNurbsPositionInterpolator;
    void setNurbsPositionInterpolatorRenderCallback(NurbsPositionInterpolatorRenderCallback node) {
        callbackRenderNurbsPositionInterpolator = node;
    }

    static NurbsPositionInterpolatorDoWithDataCallback callbackDoWithDataNurbsPositionInterpolator;
    void setNurbsPositionInterpolatorDoWithDataCallback(NurbsPositionInterpolatorDoWithDataCallback node) {
         callbackDoWithDataNurbsPositionInterpolator = node;
    }

    static OrientationInterpolatorRenderCallback callbackRenderOrientationInterpolator;
    void setOrientationInterpolatorRenderCallback(OrientationInterpolatorRenderCallback node) {
        callbackRenderOrientationInterpolator = node;
    }

    static OrientationInterpolatorDoWithDataCallback callbackDoWithDataOrientationInterpolator;
    void setOrientationInterpolatorDoWithDataCallback(OrientationInterpolatorDoWithDataCallback node) {
         callbackDoWithDataOrientationInterpolator = node;
    }

    static TimeSensorRenderCallback callbackRenderTimeSensor;
    void setTimeSensorRenderCallback(TimeSensorRenderCallback node) {
        callbackRenderTimeSensor = node;
    }

    static TimeSensorDoWithDataCallback callbackDoWithDataTimeSensor;
    void setTimeSensorDoWithDataCallback(TimeSensorDoWithDataCallback node) {
         callbackDoWithDataTimeSensor = node;
    }

    static BallJointRenderCallback callbackRenderBallJoint;
    void setBallJointRenderCallback(BallJointRenderCallback node) {
        callbackRenderBallJoint = node;
    }

    static BallJointDoWithDataCallback callbackDoWithDataBallJoint;
    void setBallJointDoWithDataCallback(BallJointDoWithDataCallback node) {
         callbackDoWithDataBallJoint = node;
    }

    static CollidableOffsetRenderCallback callbackRenderCollidableOffset;
    void setCollidableOffsetRenderCallback(CollidableOffsetRenderCallback node) {
        callbackRenderCollidableOffset = node;
    }

    static CollidableOffsetDoWithDataCallback callbackDoWithDataCollidableOffset;
    void setCollidableOffsetDoWithDataCallback(CollidableOffsetDoWithDataCallback node) {
         callbackDoWithDataCollidableOffset = node;
    }

    static IndexedLineSetRenderCallback callbackRenderIndexedLineSet;
    void setIndexedLineSetRenderCallback(IndexedLineSetRenderCallback node) {
        callbackRenderIndexedLineSet = node;
    }

    static IndexedLineSetDoWithDataCallback callbackDoWithDataIndexedLineSet;
    void setIndexedLineSetDoWithDataCallback(IndexedLineSetDoWithDataCallback node) {
         callbackDoWithDataIndexedLineSet = node;
    }

    static IndexedTriangleStripSetRenderCallback callbackRenderIndexedTriangleStripSet;
    void setIndexedTriangleStripSetRenderCallback(IndexedTriangleStripSetRenderCallback node) {
        callbackRenderIndexedTriangleStripSet = node;
    }

    static IndexedTriangleStripSetDoWithDataCallback callbackDoWithDataIndexedTriangleStripSet;
    void setIndexedTriangleStripSetDoWithDataCallback(IndexedTriangleStripSetDoWithDataCallback node) {
         callbackDoWithDataIndexedTriangleStripSet = node;
    }

    static MetadataFloatRenderCallback callbackRenderMetadataFloat;
    void setMetadataFloatRenderCallback(MetadataFloatRenderCallback node) {
        callbackRenderMetadataFloat = node;
    }

    static MetadataFloatDoWithDataCallback callbackDoWithDataMetadataFloat;
    void setMetadataFloatDoWithDataCallback(MetadataFloatDoWithDataCallback node) {
         callbackDoWithDataMetadataFloat = node;
    }

    static OdeMotorJointRenderCallback callbackRenderOdeMotorJoint;
    void setOdeMotorJointRenderCallback(OdeMotorJointRenderCallback node) {
        callbackRenderOdeMotorJoint = node;
    }

    static OdeMotorJointDoWithDataCallback callbackDoWithDataOdeMotorJoint;
    void setOdeMotorJointDoWithDataCallback(OdeMotorJointDoWithDataCallback node) {
         callbackDoWithDataOdeMotorJoint = node;
    }

    static TriangleFanSetRenderCallback callbackRenderTriangleFanSet;
    void setTriangleFanSetRenderCallback(TriangleFanSetRenderCallback node) {
        callbackRenderTriangleFanSet = node;
    }

    static TriangleFanSetDoWithDataCallback callbackDoWithDataTriangleFanSet;
    void setTriangleFanSetDoWithDataCallback(TriangleFanSetDoWithDataCallback node) {
         callbackDoWithDataTriangleFanSet = node;
    }

    static VrmlSceneRenderCallback callbackRenderVrmlScene;
    void setVrmlSceneRenderCallback(VrmlSceneRenderCallback node) {
        callbackRenderVrmlScene = node;
    }

    static VrmlSceneDoWithDataCallback callbackDoWithDataVrmlScene;
    void setVrmlSceneDoWithDataCallback(VrmlSceneDoWithDataCallback node) {
         callbackDoWithDataVrmlScene = node;
    }

    static FogRenderCallback callbackRenderFog;
    void setFogRenderCallback(FogRenderCallback node) {
        callbackRenderFog = node;
    }

    static FogDoWithDataCallback callbackDoWithDataFog;
    void setFogDoWithDataCallback(FogDoWithDataCallback node) {
         callbackDoWithDataFog = node;
    }

    static MetadataStringRenderCallback callbackRenderMetadataString;
    void setMetadataStringRenderCallback(MetadataStringRenderCallback node) {
        callbackRenderMetadataString = node;
    }

    static MetadataStringDoWithDataCallback callbackDoWithDataMetadataString;
    void setMetadataStringDoWithDataCallback(MetadataStringDoWithDataCallback node) {
         callbackDoWithDataMetadataString = node;
    }

    static InlineLoadControlRenderCallback callbackRenderInlineLoadControl;
    void setInlineLoadControlRenderCallback(InlineLoadControlRenderCallback node) {
        callbackRenderInlineLoadControl = node;
    }

    static InlineLoadControlDoWithDataCallback callbackDoWithDataInlineLoadControl;
    void setInlineLoadControlDoWithDataCallback(InlineLoadControlDoWithDataCallback node) {
         callbackDoWithDataInlineLoadControl = node;
    }

    static CollisionCollectionRenderCallback callbackRenderCollisionCollection;
    void setCollisionCollectionRenderCallback(CollisionCollectionRenderCallback node) {
        callbackRenderCollisionCollection = node;
    }

    static CollisionCollectionDoWithDataCallback callbackDoWithDataCollisionCollection;
    void setCollisionCollectionDoWithDataCallback(CollisionCollectionDoWithDataCallback node) {
         callbackDoWithDataCollisionCollection = node;
    }

    static StaticGroupRenderCallback callbackRenderStaticGroup;
    void setStaticGroupRenderCallback(StaticGroupRenderCallback node) {
        callbackRenderStaticGroup = node;
    }

    static StaticGroupDoWithDataCallback callbackDoWithDataStaticGroup;
    void setStaticGroupDoWithDataCallback(StaticGroupDoWithDataCallback node) {
         callbackDoWithDataStaticGroup = node;
    }

    static AnchorRenderCallback callbackRenderAnchor;
    void setAnchorRenderCallback(AnchorRenderCallback node) {
        callbackRenderAnchor = node;
    }

    static AnchorDoWithDataCallback callbackDoWithDataAnchor;
    void setAnchorDoWithDataCallback(AnchorDoWithDataCallback node) {
         callbackDoWithDataAnchor = node;
    }

    static BooleanTriggerRenderCallback callbackRenderBooleanTrigger;
    void setBooleanTriggerRenderCallback(BooleanTriggerRenderCallback node) {
        callbackRenderBooleanTrigger = node;
    }

    static BooleanTriggerDoWithDataCallback callbackDoWithDataBooleanTrigger;
    void setBooleanTriggerDoWithDataCallback(BooleanTriggerDoWithDataCallback node) {
         callbackDoWithDataBooleanTrigger = node;
    }

    static BooleanSequencerRenderCallback callbackRenderBooleanSequencer;
    void setBooleanSequencerRenderCallback(BooleanSequencerRenderCallback node) {
        callbackRenderBooleanSequencer = node;
    }

    static BooleanSequencerDoWithDataCallback callbackDoWithDataBooleanSequencer;
    void setBooleanSequencerDoWithDataCallback(BooleanSequencerDoWithDataCallback node) {
         callbackDoWithDataBooleanSequencer = node;
    }

    static ColorRenderCallback callbackRenderColor;
    void setColorRenderCallback(ColorRenderCallback node) {
        callbackRenderColor = node;
    }

    static ColorDoWithDataCallback callbackDoWithDataColor;
    void setColorDoWithDataCallback(ColorDoWithDataCallback node) {
         callbackDoWithDataColor = node;
    }

    static NurbsSurfaceInterpolatorRenderCallback callbackRenderNurbsSurfaceInterpolator;
    void setNurbsSurfaceInterpolatorRenderCallback(NurbsSurfaceInterpolatorRenderCallback node) {
        callbackRenderNurbsSurfaceInterpolator = node;
    }

    static NurbsSurfaceInterpolatorDoWithDataCallback callbackDoWithDataNurbsSurfaceInterpolator;
    void setNurbsSurfaceInterpolatorDoWithDataCallback(NurbsSurfaceInterpolatorDoWithDataCallback node) {
         callbackDoWithDataNurbsSurfaceInterpolator = node;
    }

    static SphereSensorRenderCallback callbackRenderSphereSensor;
    void setSphereSensorRenderCallback(SphereSensorRenderCallback node) {
        callbackRenderSphereSensor = node;
    }

    static SphereSensorDoWithDataCallback callbackDoWithDataSphereSensor;
    void setSphereSensorDoWithDataCallback(SphereSensorDoWithDataCallback node) {
         callbackDoWithDataSphereSensor = node;
    }

    static TimeTriggerRenderCallback callbackRenderTimeTrigger;
    void setTimeTriggerRenderCallback(TimeTriggerRenderCallback node) {
        callbackRenderTimeTrigger = node;
    }

    static TimeTriggerDoWithDataCallback callbackDoWithDataTimeTrigger;
    void setTimeTriggerDoWithDataCallback(TimeTriggerDoWithDataCallback node) {
         callbackDoWithDataTimeTrigger = node;
    }

    static Arc2DRenderCallback callbackRenderArc2D;
    void setArc2DRenderCallback(Arc2DRenderCallback node) {
        callbackRenderArc2D = node;
    }

    static Arc2DDoWithDataCallback callbackDoWithDataArc2D;
    void setArc2DDoWithDataCallback(Arc2DDoWithDataCallback node) {
         callbackDoWithDataArc2D = node;
    }

    static BackgroundRenderCallback callbackRenderBackground;
    void setBackgroundRenderCallback(BackgroundRenderCallback node) {
        callbackRenderBackground = node;
    }

    static BackgroundDoWithDataCallback callbackDoWithDataBackground;
    void setBackgroundDoWithDataCallback(BackgroundDoWithDataCallback node) {
         callbackDoWithDataBackground = node;
    }

    static ContactRenderCallback callbackRenderContact;
    void setContactRenderCallback(ContactRenderCallback node) {
        callbackRenderContact = node;
    }

    static ContactDoWithDataCallback callbackDoWithDataContact;
    void setContactDoWithDataCallback(ContactDoWithDataCallback node) {
         callbackDoWithDataContact = node;
    }

    static ContourPolyline2DRenderCallback callbackRenderContourPolyline2D;
    void setContourPolyline2DRenderCallback(ContourPolyline2DRenderCallback node) {
        callbackRenderContourPolyline2D = node;
    }

    static ContourPolyline2DDoWithDataCallback callbackDoWithDataContourPolyline2D;
    void setContourPolyline2DDoWithDataCallback(ContourPolyline2DDoWithDataCallback node) {
         callbackDoWithDataContourPolyline2D = node;
    }

    static Disk2DRenderCallback callbackRenderDisk2D;
    void setDisk2DRenderCallback(Disk2DRenderCallback node) {
        callbackRenderDisk2D = node;
    }

    static Disk2DDoWithDataCallback callbackDoWithDataDisk2D;
    void setDisk2DDoWithDataCallback(Disk2DDoWithDataCallback node) {
         callbackDoWithDataDisk2D = node;
    }

    static GeoElevationGridRenderCallback callbackRenderGeoElevationGrid;
    void setGeoElevationGridRenderCallback(GeoElevationGridRenderCallback node) {
        callbackRenderGeoElevationGrid = node;
    }

    static GeoElevationGridDoWithDataCallback callbackDoWithDataGeoElevationGrid;
    void setGeoElevationGridDoWithDataCallback(GeoElevationGridDoWithDataCallback node) {
         callbackDoWithDataGeoElevationGrid = node;
    }

    static IndexedTriangleSetRenderCallback callbackRenderIndexedTriangleSet;
    void setIndexedTriangleSetRenderCallback(IndexedTriangleSetRenderCallback node) {
        callbackRenderIndexedTriangleSet = node;
    }

    static IndexedTriangleSetDoWithDataCallback callbackDoWithDataIndexedTriangleSet;
    void setIndexedTriangleSetDoWithDataCallback(IndexedTriangleSetDoWithDataCallback node) {
         callbackDoWithDataIndexedTriangleSet = node;
    }

    static MotorJointRenderCallback callbackRenderMotorJoint;
    void setMotorJointRenderCallback(MotorJointRenderCallback node) {
        callbackRenderMotorJoint = node;
    }

    static MotorJointDoWithDataCallback callbackDoWithDataMotorJoint;
    void setMotorJointDoWithDataCallback(MotorJointDoWithDataCallback node) {
         callbackDoWithDataMotorJoint = node;
    }

    static Polypoint2DRenderCallback callbackRenderPolypoint2D;
    void setPolypoint2DRenderCallback(Polypoint2DRenderCallback node) {
        callbackRenderPolypoint2D = node;
    }

    static Polypoint2DDoWithDataCallback callbackDoWithDataPolypoint2D;
    void setPolypoint2DDoWithDataCallback(Polypoint2DDoWithDataCallback node) {
         callbackDoWithDataPolypoint2D = node;
    }

    static SuperEllipsoidRenderCallback callbackRenderSuperEllipsoid;
    void setSuperEllipsoidRenderCallback(SuperEllipsoidRenderCallback node) {
        callbackRenderSuperEllipsoid = node;
    }

    static SuperEllipsoidDoWithDataCallback callbackDoWithDataSuperEllipsoid;
    void setSuperEllipsoidDoWithDataCallback(SuperEllipsoidDoWithDataCallback node) {
         callbackDoWithDataSuperEllipsoid = node;
    }

    static BooleanToggleRenderCallback callbackRenderBooleanToggle;
    void setBooleanToggleRenderCallback(BooleanToggleRenderCallback node) {
        callbackRenderBooleanToggle = node;
    }

    static BooleanToggleDoWithDataCallback callbackDoWithDataBooleanToggle;
    void setBooleanToggleDoWithDataCallback(BooleanToggleDoWithDataCallback node) {
         callbackDoWithDataBooleanToggle = node;
    }

    static CoordinateDoubleRenderCallback callbackRenderCoordinateDouble;
    void setCoordinateDoubleRenderCallback(CoordinateDoubleRenderCallback node) {
        callbackRenderCoordinateDouble = node;
    }

    static CoordinateDoubleDoWithDataCallback callbackDoWithDataCoordinateDouble;
    void setCoordinateDoubleDoWithDataCallback(CoordinateDoubleDoWithDataCallback node) {
         callbackDoWithDataCoordinateDouble = node;
    }

    static MultiTextureRenderCallback callbackRenderMultiTexture;
    void setMultiTextureRenderCallback(MultiTextureRenderCallback node) {
        callbackRenderMultiTexture = node;
    }

    static MultiTextureDoWithDataCallback callbackDoWithDataMultiTexture;
    void setMultiTextureDoWithDataCallback(MultiTextureDoWithDataCallback node) {
         callbackDoWithDataMultiTexture = node;
    }

    static NurbsTrimmedSurfaceRenderCallback callbackRenderNurbsTrimmedSurface;
    void setNurbsTrimmedSurfaceRenderCallback(NurbsTrimmedSurfaceRenderCallback node) {
        callbackRenderNurbsTrimmedSurface = node;
    }

    static NurbsTrimmedSurfaceDoWithDataCallback callbackDoWithDataNurbsTrimmedSurface;
    void setNurbsTrimmedSurfaceDoWithDataCallback(NurbsTrimmedSurfaceDoWithDataCallback node) {
         callbackDoWithDataNurbsTrimmedSurface = node;
    }

    static ShapeRenderCallback callbackRenderShape;
    void setShapeRenderCallback(ShapeRenderCallback node) {
        callbackRenderShape = node;
    }

    static ShapeDoWithDataCallback callbackDoWithDataShape;
    void setShapeDoWithDataCallback(ShapeDoWithDataCallback node) {
         callbackDoWithDataShape = node;
    }

    static BoxRenderCallback callbackRenderBox;
    void setBoxRenderCallback(BoxRenderCallback node) {
        callbackRenderBox = node;
    }

    static BoxDoWithDataCallback callbackDoWithDataBox;
    void setBoxDoWithDataCallback(BoxDoWithDataCallback node) {
         callbackDoWithDataBox = node;
    }

    static GeoLocationRenderCallback callbackRenderGeoLocation;
    void setGeoLocationRenderCallback(GeoLocationRenderCallback node) {
        callbackRenderGeoLocation = node;
    }

    static GeoLocationDoWithDataCallback callbackDoWithDataGeoLocation;
    void setGeoLocationDoWithDataCallback(GeoLocationDoWithDataCallback node) {
         callbackDoWithDataGeoLocation = node;
    }

    static CylinderRenderCallback callbackRenderCylinder;
    void setCylinderRenderCallback(CylinderRenderCallback node) {
        callbackRenderCylinder = node;
    }

    static CylinderDoWithDataCallback callbackDoWithDataCylinder;
    void setCylinderDoWithDataCallback(CylinderDoWithDataCallback node) {
         callbackDoWithDataCylinder = node;
    }

    static NormalInterpolatorRenderCallback callbackRenderNormalInterpolator;
    void setNormalInterpolatorRenderCallback(NormalInterpolatorRenderCallback node) {
        callbackRenderNormalInterpolator = node;
    }

    static NormalInterpolatorDoWithDataCallback callbackDoWithDataNormalInterpolator;
    void setNormalInterpolatorDoWithDataCallback(NormalInterpolatorDoWithDataCallback node) {
         callbackDoWithDataNormalInterpolator = node;
    }

    static ScalarInterpolatorRenderCallback callbackRenderScalarInterpolator;
    void setScalarInterpolatorRenderCallback(ScalarInterpolatorRenderCallback node) {
        callbackRenderScalarInterpolator = node;
    }

    static ScalarInterpolatorDoWithDataCallback callbackDoWithDataScalarInterpolator;
    void setScalarInterpolatorDoWithDataCallback(ScalarInterpolatorDoWithDataCallback node) {
         callbackDoWithDataScalarInterpolator = node;
    }

    static TouchSensorRenderCallback callbackRenderTouchSensor;
    void setTouchSensorRenderCallback(TouchSensorRenderCallback node) {
        callbackRenderTouchSensor = node;
    }

    static TouchSensorDoWithDataCallback callbackDoWithDataTouchSensor;
    void setTouchSensorDoWithDataCallback(TouchSensorDoWithDataCallback node) {
         callbackDoWithDataTouchSensor = node;
    }

    static CattExportRecRenderCallback callbackRenderCattExportRec;
    void setCattExportRecRenderCallback(CattExportRecRenderCallback node) {
        callbackRenderCattExportRec = node;
    }

    static CattExportRecDoWithDataCallback callbackDoWithDataCattExportRec;
    void setCattExportRecDoWithDataCallback(CattExportRecDoWithDataCallback node) {
         callbackDoWithDataCattExportRec = node;
    }

    static FillPropertiesRenderCallback callbackRenderFillProperties;
    void setFillPropertiesRenderCallback(FillPropertiesRenderCallback node) {
        callbackRenderFillProperties = node;
    }

    static FillPropertiesDoWithDataCallback callbackDoWithDataFillProperties;
    void setFillPropertiesDoWithDataCallback(FillPropertiesDoWithDataCallback node) {
         callbackDoWithDataFillProperties = node;
    }

    static HAnimSegmentRenderCallback callbackRenderHAnimSegment;
    void setHAnimSegmentRenderCallback(HAnimSegmentRenderCallback node) {
        callbackRenderHAnimSegment = node;
    }

    static HAnimSegmentDoWithDataCallback callbackDoWithDataHAnimSegment;
    void setHAnimSegmentDoWithDataCallback(HAnimSegmentDoWithDataCallback node) {
         callbackDoWithDataHAnimSegment = node;
    }

    static PointLightRenderCallback callbackRenderPointLight;
    void setPointLightRenderCallback(PointLightRenderCallback node) {
        callbackRenderPointLight = node;
    }

    static PointLightDoWithDataCallback callbackDoWithDataPointLight;
    void setPointLightDoWithDataCallback(PointLightDoWithDataCallback node) {
         callbackDoWithDataPointLight = node;
    }

    static SliderJointRenderCallback callbackRenderSliderJoint;
    void setSliderJointRenderCallback(SliderJointRenderCallback node) {
        callbackRenderSliderJoint = node;
    }

    static SliderJointDoWithDataCallback callbackDoWithDataSliderJoint;
    void setSliderJointDoWithDataCallback(SliderJointDoWithDataCallback node) {
         callbackDoWithDataSliderJoint = node;
    }

    static TextRenderCallback callbackRenderText;
    void setTextRenderCallback(TextRenderCallback node) {
        callbackRenderText = node;
    }

    static TextDoWithDataCallback callbackDoWithDataText;
    void setTextDoWithDataCallback(TextDoWithDataCallback node) {
         callbackDoWithDataText = node;
    }

    static TextureBackgroundRenderCallback callbackRenderTextureBackground;
    void setTextureBackgroundRenderCallback(TextureBackgroundRenderCallback node) {
        callbackRenderTextureBackground = node;
    }

    static TextureBackgroundDoWithDataCallback callbackDoWithDataTextureBackground;
    void setTextureBackgroundDoWithDataCallback(TextureBackgroundDoWithDataCallback node) {
         callbackDoWithDataTextureBackground = node;
    }

    static TriangleSet2DRenderCallback callbackRenderTriangleSet2D;
    void setTriangleSet2DRenderCallback(TriangleSet2DRenderCallback node) {
        callbackRenderTriangleSet2D = node;
    }

    static TriangleSet2DDoWithDataCallback callbackDoWithDataTriangleSet2D;
    void setTriangleSet2DDoWithDataCallback(TriangleSet2DDoWithDataCallback node) {
         callbackDoWithDataTriangleSet2D = node;
    }

    static AppearanceRenderCallback callbackRenderAppearance;
    void setAppearanceRenderCallback(AppearanceRenderCallback node) {
        callbackRenderAppearance = node;
    }

    static AppearanceDoWithDataCallback callbackDoWithDataAppearance;
    void setAppearanceDoWithDataCallback(AppearanceDoWithDataCallback node) {
         callbackDoWithDataAppearance = node;
    }

    static CollisionSpaceRenderCallback callbackRenderCollisionSpace;
    void setCollisionSpaceRenderCallback(CollisionSpaceRenderCallback node) {
        callbackRenderCollisionSpace = node;
    }

    static CollisionSpaceDoWithDataCallback callbackDoWithDataCollisionSpace;
    void setCollisionSpaceDoWithDataCallback(CollisionSpaceDoWithDataCallback node) {
         callbackDoWithDataCollisionSpace = node;
    }

    static NurbsTextureCoordinateRenderCallback callbackRenderNurbsTextureCoordinate;
    void setNurbsTextureCoordinateRenderCallback(NurbsTextureCoordinateRenderCallback node) {
        callbackRenderNurbsTextureCoordinate = node;
    }

    static NurbsTextureCoordinateDoWithDataCallback callbackDoWithDataNurbsTextureCoordinate;
    void setNurbsTextureCoordinateDoWithDataCallback(NurbsTextureCoordinateDoWithDataCallback node) {
         callbackDoWithDataNurbsTextureCoordinate = node;
    }

    static ReceiverPduRenderCallback callbackRenderReceiverPdu;
    void setReceiverPduRenderCallback(ReceiverPduRenderCallback node) {
        callbackRenderReceiverPdu = node;
    }

    static ReceiverPduDoWithDataCallback callbackDoWithDataReceiverPdu;
    void setReceiverPduDoWithDataCallback(ReceiverPduDoWithDataCallback node) {
         callbackDoWithDataReceiverPdu = node;
    }

    static TextureCoordinateRenderCallback callbackRenderTextureCoordinate;
    void setTextureCoordinateRenderCallback(TextureCoordinateRenderCallback node) {
        callbackRenderTextureCoordinate = node;
    }

    static TextureCoordinateDoWithDataCallback callbackDoWithDataTextureCoordinate;
    void setTextureCoordinateDoWithDataCallback(TextureCoordinateDoWithDataCallback node) {
         callbackDoWithDataTextureCoordinate = node;
    }

    static NormalRenderCallback callbackRenderNormal;
    void setNormalRenderCallback(NormalRenderCallback node) {
        callbackRenderNormal = node;
    }

    static NormalDoWithDataCallback callbackDoWithDataNormal;
    void setNormalDoWithDataCallback(NormalDoWithDataCallback node) {
         callbackDoWithDataNormal = node;
    }

    static TextureTransformRenderCallback callbackRenderTextureTransform;
    void setTextureTransformRenderCallback(TextureTransformRenderCallback node) {
        callbackRenderTextureTransform = node;
    }

    static TextureTransformDoWithDataCallback callbackDoWithDataTextureTransform;
    void setTextureTransformDoWithDataCallback(TextureTransformDoWithDataCallback node) {
         callbackDoWithDataTextureTransform = node;
    }

    void render() { root.treeRender(); }
    void doWithData() { root.treeDoWithData(); }
};

class MyTextCallback extends TextDoWithDataCallback {
   public void doWithData(X3dNode node) {
      Text text = (Text) node; 
      if (text.string.length > 0)
          System.out.println(text.string[0]);
   }   
}

class helloWorld {

    public static void main(String args[]) {
        Text dummy;
        X3dSceneGraph sceneGraph = new X3dSceneGraph();
        MyTextCallback myTextCallback = new MyTextCallback();
        sceneGraph.setTextDoWithDataCallback(myTextCallback);
        sceneGraph.doWithData();
    }
};

